<?php
////////////////////////////////////////////////////////////////////////////
//This file is part of "Unak" CMS http://www.unak.net
//Author: Daniel Stoyanov daniel@unak.net, Atanas Tchobanov atanas@unak.net
//Contact: daniel@unak.net atanas@unak.net
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// UNAK-CMS is copyrighted by webdressy.com and distributed under the GPL license. Please read the LICENSE file.
////////////////////////////////////////////////////////////////////////////

//$cf["dir"]["models"]="./models";
///////////////////////////////////
//Install module
///////////////////////////////////

if($u_do=="modInstall" && $_POST["u_mod_install"]=="comments") {
	// create unak_comments table
	$db->query('CREATE TABLE unak_comments (id INTEGER NOT NULL, lang VARCHAR(3) NOT NULL, a_id INTEGER NOT NULL, author VARCHAR(30) NOT NULL,date INT(11) NOT NULL, comment TEXT NOT NULL)');
	$db->query('CREATE TABLE unak_ratings (id INTEGER NOT NULL, lang VARCHAR(3) NOT NULL, a_id INTEGER NOT NULL, user TEXT NOT NULL, rating INT(1) NOT NULL, n INTEGER NOT NULL)');
	// insert default configuration values
	$db->query('insert into unak_config values("module","comments","1")');
	$db->query('insert into unak_config values("mod_comments","defaultLang","en")');
	$db->query('insert into unak_config values("mod_comments","guestCanPost","1")');
	$db->query('insert into unak_config values("mod_comments","guestCanRate","1")');
	$db->query('insert into unak_config values("mod_comments,"show","25")');
	
	//install languages vars for module
	allLang();
	lang_files($cf['dir']['modules'].'/comments/lang/');
	$c=count($u_lang_files);
	for($i=0;$i<$c;$i++) $u_lang_files[$i]=substr($u_lang_files[$i],0,2);
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		if(false!==array_search($lang["name"][$i],$u_lang_files))
			lfile_to_db($lang["name"][$i],$cf['dir']['modules'].'/comments/lang/'.$lang["name"][$i].'.default.php');
			db_to_lfile($lang["name"][$i],$cf['dir']['lang']);
	}
	header("location:".$_SERVER['PHP_SELF']."?sl=".$sl."&u_do=cMenuModules&u_messages=".$ling['module']["installOk"]."&sid=".$sid."");
}

///////////////////////////////////
//Uninstall module
///////////////////////////////////
if($u_do=="modUninstall" && $_GET["u_mod_config"]=="comments") {
	
	// drop tables
	$db->query('drop table unak_comments');
	$db->query('drop table unak_ratings');
	// delete config vars
	$db->query('delete from unak_config where u_type="module" and u_var="comments"');
	$db->query('delete from unak_config where u_type="mod_comments"');
	// delete lang vars and update system lang files
	allLang();
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		//reset article and secion permissions
		$db->query('delete from unak_lang_'.$lang["name"][$i].' where u_type="mod_comments"');
		db_to_lfile($lang["name"][$i],$cf['dir']['lang']);
	}	
	header("location:".$_SERVER['PHP_SELF']."?sl=".$sl."&u_do=cMenuModules&u_messages=".$ling["module"]["uninstallOk"]."&sid=".$sid."");
}
///////////////////////////////////
//Info module
///////////////////////////////////
if($u_do=="modInfo" && $_GET["u_mod_config"]=="comments") {
	$u_c="This is a comments system and rating system module. This module is the first one using a new templating scheme. You can modify the aspect of the printed output by creating a different template for your forms, tables, etc. and putting it in the modules/comments/models folder. Then you can give the name of the template as an argument to the function printing the output. For example:<BR>
	_ _postCommentForm_myCommentFormTemplate_ _ will format the output with the file modules/comments/models/myCommentFormTemplate.html <BR><BR>
	
	The following functions are available in this module:<BR><BR>
	_ _postCommentLink_ _ : a link opening a layer with the comment form<BR><BR>
	_ _postCommentForm_$model_ _ : the comment form arg $model is the name of the template file<BR><BR>
	_ _showComments_$orderBy_$model_ _: printing the comments ordered by the argument $orderBy (author, id) and using the template $model<BR><BR>
	_ _postRatingLink_ _ : a link opening a layer with the rating form<BR><BR>
	_ _postRatingForm_ _ : the rating form<BR><BR>
	_ _showRatings_$type_$colors _ : Printing a colored rating bar using the GD graphics library if available. Here are the definitions of the arguments:<BR><BR>
		char $type<BR><BR>
			r = article rating<BR><BR>
			g = article global rating<BR><BR>
			d = detailed votes<BR><BR>
		charchar $colors<BR><BR>
		The first is the background color and the second is the bar color<BR><BR>
			g = gray<BR><BR>
			n = black<BR><BR>
			w = white<BR><BR>
			r = red<BR><BR>
			v = green<BR><BR>
			b = blue<BR><BR>
			y = yellow<BR><BR>
			m = magenta<BR><BR>
			c = cyan<BR><BR>
			
	_ _topArticles_$i_ _ : printing the $i top rated articles<BR><BR>";
}
///////////////////////////////////
//HTML Controls
///////////////////////////////////
//Post comments link with show/hide div form 
$function_public[]="unak_postcommentlink";
$function_public["unak_postcommentlink"][1]="Html model";
$function_public["unak_postcommentlink"]["help"]="Prints a link opening the comment form. Uses one of the html model found inside the modules/comments/models directory";

function unak_postCommentLink($html=0) {
	global $u_url, $ling, $sid;
	
	$out='<a href="javascript://" onClick="MM_showHideLayers(\'postCommentsForm\',\'\',\'show\'); MM_changeProp(\'postCommentsForm\',\'\',\'style.position\',\'relative\'); return false;" class="postCommentLink">'.$ling["mod_comments"]["postCommentLink"].'</a>';
	$out.='<div id="postCommentsForm" name="postCommentsForm" style="visibility: hidden; position: absolute; z-index:100">'.unak_postCommentForm().'
		<a href="javascript://" onClick="MM_showHideLayers(\'postCommentsForm\',\'\',\'hide\'); MM_changeProp(\'postCommentsForm\',\'\',\'style.position\',\'absolute\'); return false;">close</a>
	</div>';
	return $out;
}
//Post comments form

$function_public[]="unak_postcommentform";
$function_public["unak_postcommentform"][1]="Html model";
$function_public["unak_postcommentform"]["help"]="Prints a comment form. Uses one of the html model found inside the modules/comments/models directory";
function unak_postCommentForm($model=0) {
	global $db, $cf, $sid, $user_id, $username, $u_url, $ling, $sl, $u_a;
	
	$out="";
	$q="";
	if($model) $model=getModel($cf["dir"]["modules"].'/comments/models/'.$model.'.htm',"mod_comments");
	else $model=getModel($cf["dir"]["modules"].'/comments/models/showComments.htm',"mod_comments");
	
	if(isset($_GET["quoteComment"])) {
		$r=$db->get_row('select author,comment from unak_comments where id='.$_GET['id']);
		if(preg_match("/[0-9]/",$r->author)) $r->author=$db->get_var('select username from unak_users where id='.$r->author);
		$q="<b><i>".$r->author."</i> ".$r->comment."<b>\n";
	}
	if($cf["mod_comments"]["guestCanPost"] || $sid) {
		$out.='<form action="'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'" method="post"><table><tr><td align="right" valign="top">'.$ling["mod_comments"]["author"].'</td><td align="left" valign="top">';
		if($sid) $out.=$username.'<input type="hidden" name="u_commentsAuthor" value="'.$user_id.'"></td></tr>'; 
		else $out.='<input type="text" name="u_commentsAuthor"></td></tr>';
		$out.='<tr><td align="right" valign="top">Text: </td>
	<td align="left" valign="top"><textarea class=\"u_form\" cols="50" rows="12" name="u_commentsComment">'.$q.'</textarea></td></tr>';
		//captcha protect
	if ($cf["module"]["captcha"]&&$cf["mod_captcha"]["comment"]) {
		$out.='<tr valign="top"><td align="right">'.$ling["mod_captcha"]["code"].':</td><td align="left" valign="top">'.unak_captcha().' </td></tr>';
	}
	$out.='<tr><td colspan="2" align="center" valign="top"><input  class=\"u_form\" type="reset"> <input  class=\"u_form\" type="submit" name="u_commentsSubmit" value="'.$ling["mod_comments"]["postComment"].'"></td>
	<input type="hidden" name="u_lang" value="'.$sl.'">
	<input type="hidden" name="u_u_a" value="'.$u_a.'">
	<input type="hidden" name="u_commentsArticle" value="'.time().'">
	</table></form>';
	} else $out.=$ling["mod_comments"]["canPost"];
	return $out;
}

$function_public[]="unak_showcomments";
$function_public["unak_showcomments"][1]="Order by (id/date/author)";
$function_public["unak_showcomments"][2]="Html model";
$function_public["unak_showcomments"]["help"]="Shows the comments. Uses one of the html model found inside the modules/comments/model directory";
function unak_showComments($orderBy="id", $model=0) {
	global $cf, $db, $sid, $user_id, $turboadmin, $u_url, $ling, $sl, $u_a, $u_s;
	$start=$_GET["start"];
	$many=$_GET["many"];
	$cf["mod_comments"]["show"]=10;
	if($model) $model=getModel($cf["dir"]["modules"].'/comments/models/'.$model.'.htm',"mod_comments");
	else $model=getModel($cf["dir"]["modules"].'/comments/models/showComments.htm',"mod_comments");
	//navi
	$current_sigs=$db->get_var("select count(id) from unak_comments");
	$end = ($start+$many);
	if(isset($start) && isset($many)){
		if ($current_sigs < $end) {
			$end=$current_sigs;
		}
	
		} else {
			$start=0;
			$many=$cf["mod_comments"]["show"];
		if ($current_sigs < $many) {
		$many=$current_sigs;
		}
	}
	
	if(!$start){
		$start=0;
	} 
	if(!$many){
		$many=$cf["mod_comments"]["show"];
	}
	if(!$orderby){
		$orderby="ID";
	}

	$out.="<table border=0 cellspacing=0 cellpadding=0 width=100%>
	<tr>
	<td width=\"50%\" align=\"left\">";
			$beginning=($start-$many+1);
			if ($beginning > 0)  { 
			$beginning--;
				$out.="<a href=\"?u_s=".$u_s."&u_a=".$u_a."&sid=".$sid."&start=" . $beginning . "&many=".$many."\"><< ".$ling["mod_petition"]["previous"]."</a>"; 
			}
			
		$out.="</td><td>";
		if ($beginning > 0 && $current_sigs >= ($start+$many))  { 
			//echo " - ";
		}
		
	$out.="</td><td width=\"50%\" align=\"right\">";
		 
			if ( $current_sigs >= ($start+$many))  { 
			 	$out.="<a href=\"?u_s=".$u_s."&u_a=".$u_a."&sid=".$sid."&start=" . ($start+$many ) . "&many=".$many."\">".$ling["mod_petition"]["next"]." >></a>"; 
			 }
			
	$out.="</td>
	</tr></table>";
	//end navi
	$r=$db->get_results('select * from unak_comments where lang="'.$sl.'" and a_id="'.$u_a.'" order by '.$orderBy.' desc limit '.$start.','.$many.'');
	
	if(is_array($r)) {
		foreach ($r as $row) {
			if(preg_match("/[0-9]/",$row->author)&&!preg_match("/[a-z]/",$row->author)) $row->author=$db->get_var('select username from unak_users where id="'.$row->author.'"');
			if($cf["mod_comments"]["guestCanPost"] || is_valid()) 
			$t=str_replace("\$quoteLink",'<a href="'.$u_url.'?sl='.$sl.'&u_s='.$u_s.'&u_a='.$u_a.'&quoteComment&id='.$row->id.'&sid='.$sid.'">'.$ling["mod_comments"]["quote"].'</a>',$model); else $t=str_replace("\$quoteLink","",$model);
			$t=str_replace("\$date",date($ling["date"]["formatshort"],$row->date),$t);
			$t=str_replace("\$author",$row->author,$t);
			$out.=str_replace("\$comment",$row->comment,$t);
			if($turboadmin) $out.='<a href="'.$u_url.'?sl='.$sl.'&u_s='.$u_s.'&u_a='.$u_a.'&u_do=delComment&id='.$row->id.'&sid='.$sid.'">'.$ling["button"]["delete"].'</a>';
		}
		$out.="<table border=0 cellspacing=0 cellpadding=0 width=100%>
	<tr>
	<td width=\"50%\" align=\"left\">";
			$beginning=($start-$many+1);
			if ($beginning > 0)  { 
			$beginning--;
				$out.="<a href=\"?u_s=".$u_s."&u_a=".$u_a."&sid=".$sid."&start=" . $beginning . "&many=".$many."\"><< ".$ling["mod_petition"]["previous"]."</a>"; 
			}	
		$out.="</td><td>";
		if ($beginning > 0 && $current_sigs >= ($start+$many))  { 
			//echo " - ";
		}
	$out.="</td><td width=\"50%\" align=\"right\">"; 
			if ( $current_sigs >= ($start+$many))  { 
			 	$out.="<a href=\"?u_s=".$u_s."&u_a=".$u_a."&sid=".$sid."&start=" . ($start+$many ) . "&many=".$many."\">".$ling["mod_petition"]["next"]." >></a>"; 
			 }
	$out.="</td>
	</tr></table>";
	} else $out=$ling["mod_comments"]["nocomments"];
	return $out;
}
// Get Model
function getModel($model,$langClass) {
	global $ling;
	
	$out=file_get_contents($model);
	preg_match_all("/___([a-z0-9]+[_]?+[a-z0-9-_]*)__/im",$out,$model);
	if($c=count($model[1])) 
	for($i=0;$i<$c;$i++) {
		if(strchr($model[1][$i],"lang")) {
			$var=explode('_',$model[1][$i]);
			$out=str_replace($model[0][$i],$ling[$langClass][$var[1]],$out);
		} else {
			$out=str_replace($model[0][$i],"$".$model[1][$i],$out);
		}
	}
	return $out;
}

$function_public[]="unak_postratinglink";
$function_public["unak_postratinglink"][1]="Html model";
$function_public["unak_postratinglink"]["help"]="Shows a link to the ratings form. Uses one of the html model found inside the modules/comments/model directory";

function unak_postRatingLink($html=0) {
	global $u_url, $ling, $sid;
	
	$out='<a href="javascript://" onClick="MM_showHideLayers(\'postRatingForm\',\'\',\'show\'); MM_changeProp(\'postRatingForm\',\'\',\'style.position\',\'relative\'); return false;" class="postRatingLink">'.$ling["mod_comments"]["rate"].'</a>';
	$out.='<div id="postRatingForm" name="postRatingForm" style="visibility: hidden; position: absolute; z-index:100">'.unak_postRatingForm().'
		<a href="javascript://" onClick="MM_showHideLayers(\'postRatingForm\',\'\',\'hide\'); MM_changeProp(\'postRatingForm\',\'\',\'style.position\',\'absolute\'); return false;">close</a>
	</div>';
	return $out;
}

$function_public[]="unak_postratingform";
$function_public["unak_postratingform"]["help"]="Shows the ratings form.";

function unak_postRatingForm() {
	global $db, $cf, $sid, $user_id, $username, $u_url, $ling, $sl, $u_a;
	$out="";
	$v=false;
	if(is_valid()) $userv=$user_id; else $userv=$_SERVER['REMOTE_ADDR'];
	if($cf["mod_comments"]["guestCanRate"] || is_valid()) {
		$u=$db->get_results('select user from unak_ratings where lang="'.$sl.'" and a_id='.$u_a);
		if(is_array($u)){ 
		foreach ($u as $user) {
		$uvarr=explode(",",$user->user);
		
		if(in_array($userv,$uvarr)) $v=true;
		}
		}
		if(!$v) {
			$out='<form action="'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'" method="POST">
			<div>'.$ling['mod_comments']['rate'].' 
			<select name="u_rating">
			<option value="0" selected>'.$ling['mod_comments']['select'].'</option>
			<option value="1">1 - '.$ling['mod_comments']['1'].'</option>
			<option value="2">2 - '.$ling['mod_comments']['2'].'</option>
			<option value="3">3 - '.$ling['mod_comments']['3'].'</option>
			<option value="4">4 - '.$ling['mod_comments']['4'].'</option>
			<option value="5">5 - '.$ling['mod_comments']['5'].'</option>
			</select> <input type="submit" name="u_ratingSubmit" value="'.$ling['mod_comments']['rateit'].'"></div>
			<input type="hidden" name="u_lang" value="'.$sl.'">
			<input type="hidden" name="u_u_a" value="'.$u_a.'">
			<input type="hidden" name="u_user" value="'.$userv.'">
			</form>';
		} else $out.=$ling["mod_comments"]["voted"];
	} else $out.=$ling["mod_comments"]["canRate"];
	return $out;
}

$function_public[]="unak_toparticles";
$function_public["unak_toparticles"][1]="Num";
$function_public["unak_toparticles"]["help"]="Shows the top rated articles.";
function unak_topArticles($n=5) {
	global $db, $cf, $sid, $user_id, $username, $u_url, $ling, $sl, $u_a;
	$i=0;
	$ar=array();
	$a=$db->get_results('select a_id from unak_ratings where lang="'.$sl.'" limit 0,'.$n.'');
	if(is_array($a))
	foreach ($a as $article) {
		$aa=$db->get_results('select rating,n from unak_ratings where lang="'.$sl.'" and a_id="'.$article->a_id.'"');
		$r=0;
		foreach ($aa as $row) $r+=$row->n*$row->rating;
		$ar[$i]=$r;
		$i++;
	}
	//$ar=implode("<br>",$ar);
	return $ar[0]." ".$r;
}

if (!function_exists('str_split')) {
   function str_split($string, $split_length = 1) {
       if (!is_numeric($split_length)) {
           trigger_error('str_split() expects parameter 2 to be long, ' . gettype($split_length) . ' given', E_USER_WARNING);
           return false;
       }

       if ($split_length < 1) {
           trigger_error('str_split() The the length of each segment must be greater then zero', E_USER_WARNING);
           return false;
       }

       preg_match_all('/.{1,' . $split_length . '}/s', $string, $matches);
       return $matches[0];
   }
}

$function_public[]="unak_showratings";
$function_public["unak_showratings"][1]="Type";
$function_public["unak_showratings"][2]="Colors";
$function_public["unak_showratings"]["help"]="Shows the rating for the article.<BR> Type <BR>
	r = article rating<BR>
	d = detailed votes<BR>
Colors<BR>
	The first is the background color and the second is the bar color<BR>
	g = gray<BR>
	n = black<BR>
	w = white<BR>
	r = red<BR>
	v = green<BR>
	b = blue<BR>
	y = yellow<BR>
	m = magenta<BR>
	c = cyan<BR>
	Defaults are a red bar on white color or wr";

function unak_showRatings($type="r",$colors="wr") {
	global $db, $cf, $sid, $user_id, $username, $u_url, $ling, $sl, $u_a;
	$out='';

	list($bg,$fg)=str_split($colors,1);
	
	if($type=="r") {
		$r=$db->get_results('select rating, n from unak_ratings where lang="'.$sl.'" and a_id='.$u_a);
		$all=$db->get_var('select sum(n) from unak_ratings where lang="'.$sl.'" and a_id='.$u_a);
		if(is_array($r)) {
			$out.='<table><tr><td colspan="2" align="center"><b>'.$ling['mod_comments']['ratings'].'<b></td></tr>';
			$ra=0;
			foreach ($r as $row) $ra+=$row->rating*$row->n;
			$ra=round($ra/$all);
			$out.='<tr><td valign="middle">'.$ling['mod_comments'][$ra].'</td><td valign="middle">';
			if(function_exists("gd_info")) $out.='<img src="'.$cf["dir"]["modules"].'/comments/'.'gd.php?rating='.round(($ra/5)*100).'&bg='.$bg.'&fg='.$fg.'"> ';
			$out.=$ra.'/5</td></tr>';
			$out.='<tr><td colspan="2" align="right">'.$all.' '.$ling["mod_comments"]["votes"].'</td></tr></table>';
		} else $out=$ling["mod_comments"]["noratings"];
	}
	
/*	if($type=="g") {
		$r=$db->get_results('select rating, n from unak_ratings where lang="'.$sl.'" and a_id='.$u_a);
		if(is_array($r)) {
			
		} else $out=$ling["mod_comments"]["noratings"]; 		
	}
*/	
	if($type=="d") {
		$r=$db->get_results('select rating,n from unak_ratings where lang="'.$sl.'" and a_id='.$u_a.' order by rating desc');
		$all=$db->get_var('select sum(n) from unak_ratings where lang="'.$sl.'" and a_id='.$u_a);
		if(is_array($r)) {
			$out.='<table><tr><td colspan="2" align="center"><b>'.$ling['mod_comments']['ratings'].'<b></td></tr>';
			foreach ($r as $row) {
				$per=round(($row->n/$all)*100);
				$out.='<tr><td>'.$ling['mod_comments'][$row->rating].'</td>
				<td valign="middle">';
				if(function_exists("gd_info")) $out.='<img src="'.$cf["dir"]["modules"].'/comments/'.'gd.php?rating='.$per.'&bg='.$bg.'&fg='.$fg.'">';
				$out.=$per.'%</td></tr>';
			}
			$out.='<tr><td>'.$all.' '.$ling["mod_comments"]["votes"].'</td></tr></table>';
		} else $out=$ling["mod_comments"]["noratings"];
	}
	return $out;
}

///////////////////////////////////
//Controllers
///////////////////////////////////
if($_POST["u_commentsSubmit"]) {
	if($_POST["u_commentsComment"]!="" && $_POST["u_commentsAuthor"]!=""){
		//Captcha protect
	if ($cf["module"]["captcha"]&&$cf["mod_captcha"]["comment"]&&!captcha_audit()) {
		header('location:'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'&u_messages='.$ling["mod_captcha"]["failed"].'');	
		} else  {
	$db->query('insert into unak_comments values('.maxRow("unak_comments").',"'.$_POST["u_lang"].'","'.$_POST["u_u_a"].'","'.strip_tags($_POST["u_commentsAuthor"]).'","'.time().'","'.strip_tags($_POST["u_commentsComment"]).'")');
	header('location:'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'&u_messages=Your comment is registered.');
		}
	}
}

if($u_do=="delComment") {
	$db->query('delete from unak_comments where id='.$_GET['id']);
	header('location:'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'');
}
if($u_do=="quoteComment") {
	header('location:'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'');
}

if($_POST["u_ratingSubmit"]) {
	if($_POST['u_rating']!="0") {
			$r=$db->get_row('select id,rating,n from unak_ratings where lang="'.$_POST['u_lang'].'" and a_id="'.$_POST['u_u_a'].'" and rating='.$_POST['u_rating']);
		if(is_null($r)) {
			$db->query('insert into unak_ratings values('.maxRow("unak_ratings").',"'.$_POST["u_lang"].'","'.$_POST["u_u_a"].'","'.$_POST['u_user'].',","'.$_POST["u_rating"].'",1)');
			} else {
			$user=$db->get_var('select user from unak_ratings where lang="'.$_POST['u_lang'].'" and a_id="'.$_POST['u_u_a'].'" and rating='.$_POST['u_rating']);
			$user=$user.$_POST['u_user'].",";
			$db->query('update unak_ratings set n='.($r->n+1).', user="'.$user.'" where lang="'.$_POST["u_lang"].'" and a_id="'.$_POST["u_u_a"].'" and rating="'.$_POST["u_rating"].'"'); 
			} 
	}
	header('location:'.$u_url.'?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'');
}
?>