<?
////////////////////////////////////////////////////////////////////////////
//This file is part of "Unak" CMS http://www.unak.net
//Author: Daniel Stoyanov daniel@unak.net, Atanas Tchobanov atanas@unak.net
//Contact: daniel@unak.net atanas@unak.net
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// UNAK-CMS is copyrighted by webdressy.com and distributed under the GPL license. Please read the LICENSE file.
////////////////////////////////////////////////////////////////////////////

///////////////////////////////////
//Install module
///////////////////////////////////

if($u_do=="modInstall" && $_POST["u_mod_install"]=="multiuser") {
	$db->query('CREATE TABLE unak_group_type (id INTEGER NOT NULL PRIMARY KEY,u_type VARCHAR(10))');
	$db->query('INSERT INTO unak_group_type (id, u_type) VALUES ("1", "open")');
	$db->query('INSERT INTO unak_group_type (id, u_type) VALUES ("2", "close")');
	$db->query('INSERT INTO unak_group_type (id, u_type) VALUES ("3", "hidden")');
	$db->query('CREATE TABLE unak_groups (id INTEGER NOT NULL,title VARCHAR(255) NOT NULL,description TINYBLOB,u_type VARCHAR(10))');
	$db->query('INSERT INTO unak_groups VALUES (1, "registered users","",1)');
	$db->query('INSERT INTO unak_groups VALUES (2, "admins","",2)');
	$db->query('CREATE TABLE unak_page_permissions (id INTEGER NOT NULL PRIMARY KEY,user_id INTEGER,group_id INTEGER,page_id INTEGER NOT NULL,lang VARCHAR(4) ,permission INTEGER NOT NULL)');
	$db->query('CREATE TABLE unak_permissions_type (id INTEGER NOT NULL PRIMARY KEY,u_type VARCHAR(30))');
	$db->query('INSERT INTO unak_permissions_type VALUES ("1", "cansee")');
	$db->query('INSERT INTO unak_permissions_type VALUES ("2", "canedit")');
	$db->query('INSERT INTO unak_permissions_type VALUES ("3", "canpublish")');
	$db->query('CREATE TABLE unak_section_permissions (id INTEGER NOT NULL PRIMARY KEY,user_id INTEGER,group_id INTEGER,section_id INTEGER NOT NULL,lang VARCHAR(4),permission INTEGER)');
	$db->query('CREATE TABLE unak_user_groups (id INTEGER NOT NULL PRIMARY KEY, user_id INTEGER NOT NULL, group_id INTEGER NOT NULL, role_id INTEGER NOT NULL)');
	$db->query('INSERT INTO unak_user_groups VALUES ("1", "100","100","100")');
	$db->query('CREATE TABLE unak_roles (id INTEGER NOT NULL PRIMARY KEY, title VARCHAR(255) NOT NULL, description TINYBLOB, power VARCHAR(10) )');
	$db->query('INSERT INTO unak_roles VALUES ("1", "Admin", "Group Administrator", "10")');	
	$db->query('INSERT INTO unak_roles VALUES ("2", "Member", "Member of the group", "1")');
	$db->query('CREATE TABLE unak_files ( id INTEGER NOT NULL PRIMARY KEY, file VARCHAR(255) NOT NULL, group_id INT(11), user_id INT(11), permission INT(11))');
	$db->query('insert into unak_config values("module","multiuser","1")');
	$db->query('insert into unak_config values("mod_multiuser","defaultLang","en")');
	$db->query('insert into unak_config values("mod_multiuser","mailpass","0")');
	$db->query('insert into unak_config values("mod_multiuser","usersCanRegister","")');
	$db->query('insert into unak_config values("mod_multiuser","personalpage","")');
	$db->query('insert into unak_config values("mod_multiuser","membersec","1")');
	//install languages vars for module
	allLang();
	lang_files($cf['dir']['modules'].'/multiuser/lang/');
	$c=count($u_lang_files);
	for($i=0;$i<$c;$i++) $u_lang_files[$i]=substr($u_lang_files[$i],0,2);
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		if(false!==array_search($lang["name"][$i],$u_lang_files))
			lfile_to_db($lang["name"][$i],$cf['dir']['modules'].'/multiuser/lang/'.$lang["name"][$i].'.default.php');
			db_to_lfile($lang["name"][$i],$cf['dir']['lang']);
	}
	header("location:".$_SERVER['PHP_SELF']."?sl=".$sl."&u_do=cMenuModules&u_messages=".$ling['module']["installOk"]."&sid=".$sid."");
}

///////////////////////////////////
//Uninstall module
///////////////////////////////////
if($u_do=="modUninstall" && $_GET["u_mod_config"]=="multiuser") {
	
	// drop tables
	$db->query('drop table unak_group_type');
	$db->query('drop table unak_groups');
	$db->query('drop table unak_page_permissions');
	$db->query('drop table unak_permissions_type');
	$db->query('drop table unak_section_permissions');
	$db->query('drop table unak_user_groups');
	// delete config vars
	$db->query('delete from unak_config where u_type="module" and u_var="multiuser"');
	$db->query('delete from unak_config where u_type="mod_multiuser"');
	// update a_permissions in versions table
	$db->query('update unak_versions set a_permissions="0" where a_permissions="2"');
	// delete lang vars and update system lang files
	allLang();
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		//reset article and secion permissions
		$db->query('update unak_articles_'.$lang["name"][$i].' set permissions="0" where permissions="2"');
		$db->query('update unak_sections_'.$lang["name"][$i].' set permissions="0" where permissions="2"');
		$db->query('delete from unak_lang_'.$lang["name"][$i].' where u_type="mod_multiuser"');
		db_to_lfile($lang["name"][$i],$cf['dir']['lang']);
	}	
	header("location:".$_SERVER['PHP_SELF']."?sl=".$sl."&u_do=cMenuModules&u_messages=".$ling["module"]["uninstallOk"]."&sid=".$sid."");
}
///////////////////////////////////
//Info module
///////////////////////////////////
if($u_do=="modInfo" && $_GET["u_mod_config"]=="multiuser") {
	$u_c="Here is the module info (not ready yet)";
}



//CONVERT AJAX POSTED UNICODE 

function unicode_decode($txt) {
  return ereg_replace('%u([[:alnum:]]{4})', '&#x\1;',$txt);
}


function create_htaccess($path_and_name, $content="Order deny,allow\nDeny from all\nAllow from (null)") {
	$fp=@fopen($path_and_name,"w");
	$ret=@fputs($fp,$content);
	@fclose ($fp);
	return $ret;
	
}

function create_index($path_and_name, $id) {
global $u_url;
	$content='<?php header("location:'.$u_url.'?u_a='.$id.'");>';
	$fp=fopen($path_and_name,"w");
	$ret=@fputs($fp,$content);
	fclose ($fp);
	return $ret;
}


//////////////////////////////////////
// FUNCTIONS FOR USER IMAGES AND FILES
//////////////////////////////////////

function u_images_m() {
	global $sid, $u_images,$cf,$user_id,$username;
	$dir = $cf["unak"]["root"]."/users/".$username."/images";
	$u_images=array();
	if (is_dir($dir)) {
	    if ($dh = opendir($dir)) {
	        $i=0;
			while (($file = readdir($dh)) !== false) {
			if(strstr($file,$username."_")){ //only user files
	            $u_images[$i]["path"]=$dir."/".$file;
				$u_images[$i]["url"]="users/".$username."/images/".$file;
				$u_images[$i]["file"]=$file;
				$i++;
				}
	        }
	        closedir($dh);
	    }
	}
}

// Retrieve all downloads (files)

function u_files_m() {
	global $sid,$u_files,$user_id,$cf,$username;	
	
	$dir = $cf['dir']['files'];
	$u_files=array();
	if (is_dir($dir)) {
	    if ($dh = opendir($dir)) {
	        $i=0;
			while (($file = readdir($dh)) !== false) {
			if(strstr($file,$username."_")){ //only user files
	            $u_files[$i]["path"]=$cf['dir']['files']."/".$file;
				$u_files[$i]["url"]="?u_act=download&dfile=".$file;
				$u_files[$i]["file"]=$file;
				$u_files[$i]["type"]= right($file,3);
				$i++;
				}
	        }
	        closedir($dh);
	    }
	}
}


function __u_mdo_actions__(){
///////////////////////////////
// ACTIONS FOR USERS (u_mdo)
///////////////////////////////
}

if($_POST["u_mdo"] || $_GET["u_mdo"])
	$u_mdo=$_POST["u_mdo"].$_GET["u_mdo"]; 
else $u_mdo="";


//LOG ALL ADMIN ACTIVITY
if($sid&&$u_mdo){
	make_log("s",$u_a);
}

if($turboadmin!=5) $cf['dir']['images']="users/".$username."/images";
else $cf['dir']['images']="images";

if($tree[$u_a]["author"]&&$tree[$u_a]["author"]!="anonymous"&&@file_exists($cf['dir']['templates']."/".$cf['current']['template']."/index_users.html")) $cf['user']['index']="index_users.html";

if($tree[$u_a]["author"]&&$tree[$u_a]["author"]!="anonymous"&&@file_exists($cf['dir']['templates']."/".$cf['current']['template']."/index_users_".$tree[$u_a]["author"].".html")) $cf['user']['index']="index_users_".$tree[$u_a]["author"].".html";

if($cf['user']['index'])
$file_template=$cf['dir']['templates']."/".$cf['current']['template']."/".$cf['user']['index'];

if($sid) { //user protected functions



function _u_addA(){
//ADD ARTICLE 
}

// Add Article
if($u_mdo=="addA"){
if(strstr($_GET["u_a"],"s")) $u_a=$db->get_var("select min(id) from unak_articles_".$sl." where section=".$u_s."");
	//ADD FORM MUST BE OPENED AND CLOSED IN THE TEMPLATE
	$u_c.='
	<input type="image" src="lang/'.$sl.'/save.gif" border="0" align="middle"> 
	<input type="hidden" id="savequit" name="savequit" value="1">';
	$u_c.='<a href="?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'"><img src="lang/'.$sl.'/cancel.gif" border="0" align="middle"></a><BR>';
	$u_c.="<BR>".$ling['editor']['title'].':&nbsp;<BR><input  type="text" name="u_title" class="u_form" value="'.$u_ac["title"].'" size="70">';
	$u_c.='<BR><BR>URL title:&nbsp;<BR><input class="u_form"  type="text" name="u_titleascii"  value="'.$u_ac["titleascii"].'" size="70"><BR>';
	// HTMLAREA
	
	if($cf["abstract"]["wysiwyg"]) $absheigth="150";
	else $absheigth="50";
	
	$u_c.='<BR>'.$ling["article"]["abstract"].':<BR>
	<textarea class="u_form"  id="u_abstract" name="u_abstract" class="u_form" style="width:100%; height:'.$absheigth.'px">'.$u_ac["abstract"].'</textarea>';
	
	$u_c.=$ling["article"]["text"].':<BR>
	<textarea class="u_form"  id="u_content" name="u_content" style="width:100%; height:'.$cf['editor']['height'].'px">'.$u_ac["content"].'</textarea>';
	
	$u_c.=$ling["versions"]["comments"].':<BR>
	<textarea class="u_form" id="u_comment" name="u_comment" style="width:100%; height:'.$absheigth.'px">'.$comment.'</textarea>';
	
	$u_c.=unak_adminkeywords();
	
	if($tree[$tree[$u_a]["parent_id"]]["author"]==$username||(canEditPage($tree[$u_a]["parent_id"],$username)&&!canEditSection($u_s,$username)))
	$author=$username;
	else
	$author=$tree[$tree[$u_a]["parent_id"]]["author"];
	$u_c.='<input class="u_form"  type="hidden" name="u_a" value="'.$u_a.'">
	<input class="u_form"  type="hidden" name="u_s" value="'.$u_s.'">
	<input class="u_form"  type="hidden" name="u_author" value="'.$author.'">
	<input class="u_form"  type="hidden" name="u_position" value="'.$u_a.'">
	<input class="u_form"  type="hidden" name="sl" value="'.$sl.'">
	<input class="u_form"  type="hidden" name="sid" value="'.$sid.'">
	<input class="u_form"  type="hidden" name="u_mdo" value="caddA">';
	$u_c.='<BR>
	<input type="image" src="lang/'.$sl.'/save.gif" border="0" align="middle"> 
	<input type="hidden" id="savequit" name="savequit" value="1">';
	$u_c.='<a href="?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'"><img src="lang/'.$sl.'/cancel.gif" border="0" align="middle"></a><BR>';
}

function _u_caddA(){
//ADD ARTICLE 
}

if($u_mdo=="caddA" && (canEditSection($u_s,$username) || canEditPage($u_a,$username)) && field_validator("Title",$_POST["u_title"],"string",$min_length="1",$max_length="1000")) {
	// POSITION
	if(empty($_POST["u_position"])) $parent="0";
	else $parent=$_POST["u_position"];
	// END POSITION
	$u_content=str_replace("\"","&quote;",$_POST["u_content"]);
	$u_content=preg_replace("/__([a-z0-9 ]+[_]?[a-z0-9'\(\)\"\[\]\{\} ]+[_]?[a-z0-9]+[_]?[a-z0-9]*)__/im","",$u_content);
	$u_abstract=str_replace("\"","&quote;",$_POST["u_abstract"]);
	$u_abstract=preg_replace("/__([a-z0-9 ]+[_]?[a-z0-9'\(\)\"\[\]\{\} ]+[_]?[a-z0-9]+[_]?[a-z0-9]*)__/im","",$u_abstract);
	//a hack for processing textarea in forms
	$u_content=eregi_replace("<textarea class=\"u_form\" ","<u_textarea",$u_content);
	$u_content=eregi_replace("</textarea>","</u_textarea>",$u_content);
	if(strstr($_POST["u_position"],"s")){
		$sec=substr($_POST["u_position"],1,1);
		$parent="0";
		}
	else $sec=$u_s;
	
	//end hack
	allLang();
	if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
		for($i=0;$i<$c;$i++) {
			if($lang["sync"][$i]) {
				$max_art=maxRow("unak_articles_".$lang["name"][$i]);
				$ordr=$db->get_var('select max(ordr) from unak_articles_'.$lang["name"][$i].' where section='.$sec.' and parent='.$parent.'')+1;
				$db->query('insert into unak_articles_'.$lang["name"][$i].' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($_POST["u_title"],ENT_QUOTES).'","'.htmlspecialchars($_POST["u_titleascii"],ENT_QUOTES).'","'.$sec.'","'.$parent.'","'.$_POST["u_author"].'","'.time().'","'.$_POST["u_type"].'","0","'.$u_content.'","'.$u_abstract.'","'.$_POST["headimg_name"].'","'.$_POST["headimg_size"].'","'.$_POST["headimg_align"].'","'.$_POST["headimg_text"].'","'.strtotime($_POST["u_createdate"]).'")');
				$db->query('insert into unak_versions values("'.maxRow("unak_versions").'","'.$lang["name"][$i].'","'.htmlspecialchars($_POST["u_comment"],ENT_QUOTES).'","'.$max_art.'","'.htmlspecialchars($_POST["u_title"],ENT_QUOTES).'","'.$sec.'","'.$author.'","'.time().'","'.$_POST["u_type"].'","0","0","'.$u_content.'","'.$u_abstract.'")');
			}
		}
	} else {
		$max_art=maxRow("unak_articles_".$sl);
		$ordr=$db->get_var('select max(ordr) from unak_articles_'.$sl.' where section='.$sec.' and parent='.$parent.'')+1;
		$db->query('insert into unak_articles_'.$sl.' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($_POST["u_title"],ENT_QUOTES).'","'.htmlspecialchars($_POST["u_titleascii"],ENT_QUOTES).'","'.$sec.'","'.$parent.'","'.$_POST["u_author"].'","'.time().'","'.$_POST["u_type"].'","0","'.$u_content.'","'.$u_abstract.'","'.$_POST["headimg_name"].'","'.$_POST["headimg_size"].'","'.$_POST["headimg_align"].'","'.$_POST["headimg_text"].'","'.strtotime($_POST["u_createdate"]).'");');
		$db->query('insert into unak_versions values("'.maxRow("unak_versions").'","'.$sl.'","'.htmlspecialchars($_POST["u_comment"],ENT_QUOTES).'","'.$max_art.'","'.htmlspecialchars($_POST["u_title"],ENT_QUOTES).'","'.$sec.'","'.$author.'","'.time().'","'.$_POST["u_type"].'","0","0","'.$u_content.'","'.$u_abstract.'")');
	}
	
	if($_POST["u_description"]!="")
		$db->query('insert into unak_options_articles (id,a_id,lang,opt,valeur) values("'.maxRow("unak_options_articles").'","'.$max_art.'","'.$sl.'","description","'.$_POST["u_description"].'")');
	
	if($_POST["u_keywords"]!="")
		$db->query('insert into unak_options_articles (id,a_id,lang,opt,valeur) values("'.maxRow("unak_options_articles").'","'.$max_art.'","'.$sl.'","keywords","'.$_POST["u_keywords"].'")');
		
	// HEAD IMAGE
	$headimg_text=addslashes(str_replace("\"","&quote;",$_POST["headimg_text"]));
	if($u_ac["headimg_name"]&&$_POST["headimg_name"]=="no") {
		$db->query('update unak_articles_'.$sl.' set headimg_name="", headimg_size="", headimg_align="", headimg_text="" where id='.$u_a.'');
	} else {
	if($u_ac["headimg_name"]&&$_POST["headimg_name"]!="no")
		$db->query('update unak_articles_'.$sl.' set headimg_name="'.$_POST["headimg_name"].'", headimg_size="'.$_POST["headimg_size"].'", headimg_align="'.$_POST["headimg_size"].'", headimg_text="'.$headimg_text.'" where id='.$u_a.'');
	}
if($_POST["savequit"]==1)
header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."&u_a=".$max_art."&u_messages=".urlencode($ling['msg']['articleadded'])."&sid=".$sid."");
else
header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."&u_a=".$max_art."&u_do=editA&u_messages=".urlencode($ling['msg']['articleadded'])."&sid=".$sid."");
}



//EDITING CONDITIONS


function _u_editA(){
// Edit Article
}


if($u_mdo=="editA" && (canEditSection($u_s,$username) || canEditPage($u_a,$username))) {	
	getArticle($u_a);

//EDIT FORM MUST BE OPENED AND CLOSED IN THE TEMPLATE
	$u_c.='<input  type="image" src="lang/'.$sl.'/save.gif" border="0" align="middle" > 
	<input  type="image" src="lang/'.$sl.'/savequit.gif" border="0" align="middle" onclick="document.getElementById(\'savequit\').value=1">  
	<input type="hidden" id="savequit" name="savequit" value="">';
	$u_c.=' <a href="?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'"><img src="lang/'.$sl.'/cancel.gif" border="0" align="middle"></a><BR><BR>';
	$u_c.=$ling['editor']['title'].':<BR><input class="u_form"  type="text" id="u_title" name="u_title" class="u_form" value="'.$u_ac["title"].'" size="70">';
	$u_c.='<BR><BR>URL title:&nbsp;<BR><input class="u_form"  type="text" name="u_titleascii" class="u_form" value="'.$u_ac["titleascii"].'" size="70"><BR>';
	
	// FCKEDITOR
	
	if($cf["abstract"]["wysiwyg"]) $absheigth="150";
	else $absheigth="50";
	
	$u_c.='<BR>'.$ling["article"]["abstract"].':<BR>
	<textarea class="u_form"  id="u_abstract" name="u_abstract" class="u_form" style="width:100%; height:'.$absheigth.'px">'.$u_ac["abstract"].'</textarea>';
	
	$u_c.=$ling["article"]["text"].':<BR>
	<textarea class="u_form"  id="u_content" name="u_content" style="width:100%; height:'.$cf['editor']['height'].'px">'.$u_ac["content"].'</textarea>';
	
	if($use_version_id) 
	$comment=$db->get_var('select comment from unak_versions where id="'.$use_version_id.'"');
	else {
	$cq=$db->get_row('select comment from unak_versions where a_id="'.maxRow("unak_versions").'"');
	$comment=$cq->comment;
	}
	
	$u_c.=$ling["versions"]["comments"].':<BR>
	<textarea class="u_form" id="u_comment" name="u_comment" style="width:100%; height:'.$absheigth.'px">'.$comment.'</textarea>';
	
	$u_c.=unak_adminkeywords();
	
	$u_c.='<input class="u_form"  type="hidden" name="u_a" value="'.$u_a.'">
	<input class="u_form"  type="hidden" name="u_s" value="'.$u_s.'">
	<input class="u_form"  type="hidden" name="sl" value="'.$sl.'">
	<input class="u_form"  type="hidden" name="sid" value="'.$sid.'">
	<input class="u_form"  type="hidden" name="u_mdo" value="ceditA">';
	
	$u_c.='<BR><input  type="image" src="lang/'.$sl.'/save.gif" border="0" align="middle" > 
	<input  type="image" src="lang/'.$sl.'/savequit.gif" border="0" align="middle" onclick="document.getElementById(\'savequit\').value=1">';
	$u_c.=' <a href="?sid='.$sid.'&u_s='.$u_s.'&u_a='.$u_a.'"><img src="lang/'.$sl.'/cancel.gif" border="0" align="middle"></a><BR>';
}

function _u_ceditA(){
//Record edited Article
}

if($u_mdo=="ceditA" && (canEditSection($u_s,$username) || canEditPage($u_a,$username)) && field_validator("Title",$_POST["u_title"],"string",$min_length="1",$max_length="1000")) {

	$u_content=str_replace("\"","&quote;",$_POST["u_content"]);
	$u_content=preg_replace("/__([a-z0-9 ]+[_]?[a-z0-9'\(\)\"\[\]\{\} ]+[_]?[a-z0-9]+[_]?[a-z0-9]*)__/im","",$u_content);
	$u_abstract=str_replace("\"","&quote;",$_POST["u_abstract"]);
	$u_abstract=preg_replace("/__([a-z0-9 ]+[_]?[a-z0-9'\(\)\"\[\]\{\} ]+[_]?[a-z0-9]+[_]?[a-z0-9]*)__/im","",$u_abstract);
	//a hack for processing textarea in forms
	$u_content=eregi_replace("<textarea class=\"u_form\" ","<u_textarea",$u_content);
	$u_content=eregi_replace("</textarea>","</u_textarea>",$u_content);
	//end hack
	
	// update unak_articles
	$db->query('update unak_articles_'.$sl.' set title="'.htmlspecialchars(trim($_POST["u_title"]),ENT_QUOTES).'",titleascii="'.htmlspecialchars(trim($_POST["u_titleascii"]),ENT_QUOTES).'", editdate="'.time().'", statut="'.$_POST["u_type"].'", permissions="'.$_POST["u_perm"].'", content="'.$u_content.'", abstract="'.$u_abstract.'", createdate="'.strtotime($_POST["u_createdate"]).'" where id="'.$u_a.'"');
	//insert version
	$db->query('insert into unak_versions values("'.maxRow("unak_versions").'","'.$sl.'","'.htmlspecialchars($_POST["u_comment"],ENT_QUOTES).'","'.$u_a.'","'.htmlspecialchars($_POST["u_title"],ENT_QUOTES).'","'.$sec.'","'.$author.'","'.time().'","'.$_POST["u_type"].'","0","0","'.$u_content.'","'.$u_abstract.'")');
	
	// TEMPLATE
	$a_template=$db->get_row('select id from unak_options_articles where a_id="'.$u_a.'" and lang="'.$sl.'" and opt="template"');
if($a_template&&$_POST["u_template"]=="default") {
		$db->query('delete from unak_options_articles where a_id='.$u_a.' and lang="'.$sl.'" and opt="template"');
	} else {
	if($a_template&&$_POST["u_template"]!="default")
		$db->query('update unak_options_articles set valeur="'.$_POST["u_template"].'" where a_id="'.$u_a.'" and lang="'.$sl.'" and opt="template"');
		elseif($_POST["u_template"]!="default"&&$_POST["u_template"]!=$cf["default"]["template"])
		$db->query('insert into unak_options_articles (id,a_id,lang,opt,valeur) values("'.maxRow("unak_options_articles").'","'.$u_a.'","'.$sl.'","template","'.$_POST["u_template"].'")');
}
	// KEYWORDS AND DESCRIPTION
$a_keywords=$db->get_row('select id from unak_options_articles where a_id="'.$u_a.'" and lang="'.$sl.'" and opt="keywords"');
if($a_keywords) {
	if($_POST["u_keywords"]=="")
		$db->query('delete from unak_options_articles where a_id='.$u_a.' and lang="'.$sl.'" and opt="keywords"');
	else
		$db->query('update unak_options_articles set valeur="'.$_POST["u_keywords"].'" where a_id="'.$u_a.'" and lang="'.$sl.'" and opt="keywords"');
	} else { //no keywords
	if($_POST["u_keywords"]!="")
		$db->query('insert into unak_options_articles (id,a_id,lang,opt,valeur) values("'.maxRow("unak_options_articles").'","'.$u_a.'","'.$sl.'","keywords","'.$_POST["u_keywords"].'")');
	}
	
$a_description=$db->get_row('select id from unak_options_articles where a_id="'.$u_a.'" and lang="'.$sl.'" and opt="description"');
if($a_description) {
	if($_POST["u_description"]=="")
		$db->query('delete from unak_options_articles where a_id='.$u_a.' and lang="'.$sl.'" and opt="description"');
	else
		$db->query('update unak_options_articles set valeur="'.$_POST["u_description"].'" where a_id="'.$u_a.'" and lang="'.$sl.'" and opt="description"');
	} else { //no description
	if($_POST["u_description"]!="")
		$db->query('insert into unak_options_articles (id,a_id,lang,opt,valeur) values("'.maxRow("unak_options_articles").'","'.$u_a.'","'.$sl.'","description","'.$_POST["u_description"].'")');
	}
	
	// HEAD IMAGE

	if($_POST["headimg_name"]=="no") {
		$db->query('update unak_articles_'.$sl.' set headimg_name="", headimg_size="", headimg_align="", headimg_text="" where id='.$u_a.'');
	} else {
	
$u_headimg_text=addslashes(str_replace("\"","&quote;",$_POST["headimg_text"]));
		$db->query('update unak_articles_'.$sl.' set headimg_name="'.$_POST["headimg_name"].'", headimg_size="'.$_POST["headimg_size"].'", headimg_align="'.$_POST["headimg_align"].'",
headimg_text="'.$u_headimg_text.'" where id='.$u_a.'');
//	$db->debug();
	}
	
if($_POST["savequit"]==1)
header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."&u_a=".$u_a."&u_messages=".urlencode($ling['msg']['articleedited'])."&sid=".$sid."");
else
header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."&u_a=".$u_a."&u_mdo=saveA&u_messages=".urlencode($ling['msg']['articleedited'])."&sid=".$sid."");
}
	
function _u_delA(){
// Delete Article
}

if($u_mdo=="delA" && canPublish($u_a,$u_s,$username)) {
	
	//get article parent and ordr
	$u_ao=$db->get_var('select ordr from unak_articles_'.$sl.' where id='.$u_a);
	$u_ap=$db->get_var('select parent from unak_articles_'.$sl.' where id='.$u_a);
	allLang();
	if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
		for($i=0;$i<$c;$i++) {
			if($lang["sync"][$i]) {
				// update ordr
				$q=$db->get_results('select id from unak_articles_'.$lang["name"][$i].' where section="'.$u_s.'" and parent ="'.$u_ap.'" and ordr>'.$u_ao);
				$j=$u_ao;
				if(is_array($q))
				foreach($q as $a) {
					$db->query('update unak_articles_'.$lang["name"][$i].' set ordr="'.$j.'" where id="'.$a->id.'"');
					$j++;
				}
				// delete the article
				delA($u_a,$lang["name"][$i]);
			}
		}
	} else {
		// update ordr
		$q=$db->get_results('select id from unak_articles_'.$lang["name"][$i].' where section="'.$u_s.'" and parent ="'.$u_ap.'" and ordr>"'.$u_ao.'"');
		$j=$u_ao;
		if(is_array($q))
		foreach($q as $a) {
			$db->query('update unak_articles_'.$lang["name"][$i].' set ordr="'.$j.'" where id="'.$a->id.'"');
			$j++;
		}
		// delete the article
		delA($u_a,$sl);
	}
	header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."u_a=".$u_a."&u_messages=".urlencode($ling['msg']['articledeleted'])."&sid=".$sid."");
}

function _u_cpublishA(){ 
//RECORD CONDITIONS 
}

if($u_mdo=="cpublishA" && canPublish($u_a,$u_s,$username)) {
	getArticle($u_a);
	if($_GET["frompreview"]) {
	if($_GET["v_online"]=="off") $online="0";
	elseif($_GET["v_online"]=="on") $online="1";
	if($online==1) {
	if($u_ac["permissions"]==5)	
	$db->query('update unak_articles_'.$sl.' set permissions="5" where id="'.$u_a.'"');
	else
	$db->query('update unak_articles_'.$sl.' set permissions="1" where id="'.$u_a.'"');
	//$db->debug();
	} else {
	if($tree[$u_a]["permissions"]!=2) $db->query('update unak_articles_'.$sl.' set permissions="0" where id="'.$u_a.'"');
	}
	
	} else {
	//$vid=$_GET["use_version_id"];
	//$use_version_id=$_GET["use_version_id"];
	// GET POSITION
	$u_ap=$db->get_var('select parent from unak_articles_'.$sl.' where id="'.$u_a.'"');
	$u_ao=$db->get_var('select ordr from unak_articles_'.$sl.' where id="'.$u_a.'"');
	//update the articles table
	$db->query('update unak_articles_'.$sl.' set title="'.$u_ac["title"].'", titleascii="'.$u_ac["titleascii"].'", ordr="'.$u_ao.'", parent="'.$u_ap.'", author="'.$u_ac["author"].'",editdate="'.time().'", statut="'.$u_ac["statut"].' ", permissions="'.$u_ac["permissions"].'", content="'.$u_ac["content"].'" where id='.$u_a.'');
	
	}	header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."&u_a=".$u_a."&use_version_id=".$vid."&u_messages=".urlencode($ling['msg']['versionpublished'])."&sid=".$sid."");
}

function _u_cstatusA(){
//Show/Hide Article
};

if($u_mdo=="cstatusA" && canPublish($u_a,$u_s,$username)) {
	getArticle($u_a);
	if($_GET["v_online"]=="off") $online="0";
	elseif($_GET["v_online"]=="on") $online="1";		
	if($online==1) {
	if($u_ac["permissions"]==5)	
	$db->query('update unak_articles_'.$sl.' set permissions="5" where id="'.$u_a.'"');
	else
	$db->query('update unak_articles_'.$sl.' set permissions="1" where id="'.$u_a.'"');
	//$db->debug();
	} else {
	if($tree[$u_a]["permissions"]!=2) $db->query('update unak_articles_'.$sl.' set permissions="0" where id="'.$u_a.'"');
	}
header("location:".$u_url."?sl=".$sl."&u_s=".$u_s."&u_a=".$u_a."&use_version_id=".$vid."&u_messages=".urlencode($ling['msg']['versionpublished'])."&sid=".$sid."");
}

function _u_cUpdateTree(){
//UPDATE TREE
}

getArticle($u_a);
if($u_mdo=="cUpdateTree" && (canEditSection($u_s,$username)||canEditPage($u_a,$username))){
eval(stripslashes($_POST["tree-update-value"]));
allLang();
foreach($upData as $uptree) {
	if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
			for($k=0;$k<$c;$k++) if($lang["sync"][$k]) {
			if(!strstr($uptree["id"],"new-")) {
			if($_COOKIE["part_tree"]==$u_a&&$uptree["id"]!=$u_a&&$uptree["parent"]=="0") $uptree["parent"]=$u_a;
if($_COOKIE["part_tree"]==$u_a&&$uptree["id"]==$u_a) {
$uptree["ordre"]=$u_ac["ordr"];
//print "tuk".$uptree["ordre"];
}
			//limit to partial trees 

			$db->query('update unak_articles_'.$lang["name"][$k].' set parent="'.$uptree["parent"].'", ordr="'.$uptree["ordre"].'", statut="'.$uptree["type"].'" where id="'.$uptree["id"].'"');	
			} elseif(strstr($uptree["id"],"new-")) {
			if($_COOKIE["part_tree"]==$u_a&&$uptree["parent"]=="0") $uptree["parent"]=$u_a; 
			//limit to partial trees 
			$max_art=maxRow("unak_articles_".$lang["name"][$k]);
			$db->query('insert into unak_articles_'.$lang["name"][$k].' values("'.$max_art.'","'.$uptree["ordre"].'","'.htmlspecialchars( urldecode($uptree["title"]),ENT_QUOTES).'","'.htmlspecialchars( urldecode($uptree["urltitle"]),ENT_QUOTES).'","'.$u_s.'","'.$uptree["parent"].'","'.$username.'","'.time().'","'.$uptree["type"].'","0","","","","","","","'.time().'")');
			}
			}
	} else {
		if(!strstr($uptree["id"],"new-")) {		if($_COOKIE["part_tree"]==$u_a&&$uptree["id"]!=$u_a&&$uptree["parent"]=="0") $uptree["parent"]=$u_a; 
if($_COOKIE["part_tree"]==$u_a&&$uptree["id"]==$u_a) $uptree["ordre"]=$u_ac["ordr"];
//print "tuk".$uptree["ordre"];
		//limit to partial trees 
			$db->query('update unak_articles_'.$sl.' set parent="'.$uptree["parent"].'", statut="'.$uptree["type"].'", ordr="'.$uptree["ordre"].'" where id="'.$uptree["id"].'"');	
		} elseif(strstr($uptree["id"],"new-")) {
		if($_COOKIE["part_tree"]==$u_a&&$uptree["parent"]=="0") $uptree["parent"]=$u_a; //limit to partial trees 
			$max_art=maxRow("unak_articles_".$sl);
			$db->query('insert into unak_articles_'.$sl.' values("'.$max_art.'","'.$uptree["ordre"].'","'.htmlspecialchars( urldecode($uptree["title"]),ENT_QUOTES).'","'.htmlspecialchars( urldecode($uptree["urltitle"]),ENT_QUOTES).'","'.$u_s.'","'.$uptree["parent"].'","'.$username.'","'.time().'","'.$uptree["type"].'","0","","","","","","","'.time().'")');
		
		}
	}
	if($tree[$uptree["id"]]["title"]!=$uptree["title"])
	$db->query('update unak_articles_'.$sl.' set  title="'.htmlspecialchars( urldecode($uptree["title"]),ENT_QUOTES).'",titleascii="'.htmlspecialchars( urldecode($uptree["urltitle"]),ENT_QUOTES).'" where id="'.$uptree["id"].'"');
}
if($_COOKIE["part_tree"])
header("location:".$u_url."?u_s=".$u_s."&u_a=".$u_a."&sid=".$sid."&part_tree=".$_COOKIE["part_tree"]."&u_mdo=editpage");
else
header("location:".$u_url."?u_s=".$u_s."&u_a=".$u_a."&sid=".$sid."&u_mdo=editpage");
}

function _u_cMenu(){
//small command menu for users
}

if($u_mdo=="cMenu") {		
		$u_c.='<table cellpadding="2" cellspacing="1" border="0" class="adminPanel">';
		// IMAGES
		$u_c.='<tr><td valign="top" align="center"><div align="center" class="adminTitles" style="height:30px"><H3>'.$ling["images"]["images"].'</H3></div>';
		u_images_m();
		$cs=count($u_images);
		$u_c.='<table cellpadding="2" cellspacing="1" border="0">';
		$u_c.='<tr><td valign="top" >'.$ling["images"]["available"].'</td>';
		$u_c.='<td valign="top" rowspan="4"><iframe id="preview" style="width:150px; height:150px;" class="adminPanel"></iframe></td></tr>';
		$u_c.='<tr><td valign="top" >';
		$u_c.='<form action="'.$_SERVER['PHP_SELF'].'?sid='.$sid.'" method="post">';
		$u_c.='<select class="u_form" name="dfile" id="dfile" >';
		for($i=0;$i<$cs;$i++) {
			$u_c.='<option value="'.$u_images[$i]["url"].'">'.$u_images[$i]["file"].'</option>';
		}
		$u_c.='</select>&nbsp;<input class="u_form"  type="button"  value="Preview" onClick="var sel=document.getElementById(\'dfile\'); var value=sel.options[sel.selectedIndex].value; document.getElementById(\'preview\').src=value;">&nbsp;';
		$u_c.='<input class="u_form"  type="hidden" name="u_mdo" value="deleteFile">';
		$u_c.='<input class="u_form"  type="submit"  value="Delete" onClick="javascript:if(confirm(\''.$ling['confirm']['action'].'\')) return true;return false;"></form></td></tr>';
		$u_c.='<tr><td >'.$ling["images"]["upload"].'</td></tr>';
		$u_c.='<tr><td valign="top" >';
		$u_c.='<form action="'.$_SERVER['PHP_SELF'].'?sid='.$sid.'" enctype="multipart/form-data" method="post">';
		$u_c.='<input class="u_form"  type="file" name="file" >&nbsp;&nbsp;';
		$u_c.='<input class="u_form"  type="hidden" name="u_mdo" value="uploadImg">';
		$u_c.='<input class="u_form"  type="submit" name=""  value="'.$ling["button"]["upload"].'"></form></td></tr>';
		$u_c.='</table>';
		$u_c.='</td></tr>';
		// FILES
		$u_c.='<tr><td valign="top"><div align="center" class="adminTitles" style="height:30px"><H3>'.$ling["files"]["files"].'</H3></div>';
		u_files_m();
		$cs=count($u_files);
		$u_c.='<table cellpadding="2" cellspacing="2" border="0">';
		$u_c.='<tr><td valign="top" >'.$ling["files"]["available"].'</td></tr>';
		$u_c.='<tr><td valign="top" >';
		$u_c.='<form action="'.$_SERVER['PHP_SELF'].'?sid='.$sid.'" method="post">';
		$u_c.='<select class="u_form" id="dfile" name="dfile" >';
		for($i=0;$i<$cs;$i++) {
			$u_c.='<option value="'.$u_files[$i]["path"].'">'.$u_files[$i]["file"].'</option>';
		}
		$u_c.='</select>&nbsp;<input class="u_form"  type="submit" value="'.$ling["button"]["delete"].' " onClick="javascript:if(confirm(\''.$ling['confirm']['action'].'\')) return true;return false;"></td></tr>';
		$u_c.='<input class="u_form"  type="hidden" name="u_mdo" value="deleteFile"></form>';
		$u_c.='<tr><td align="left" >'.$ling["button"]["upload"].'</td></tr>';
		$u_c.='<tr><td valign="top" >';
		$u_c.='<form action="'.$_SERVER['PHP_SELF'].'?sid='.$sid.'" enctype="multipart/form-data" method="post">';
		$u_c.='<input class="u_form"  type="file" name="file">&nbsp;&nbsp;';
		$u_c.='<input class="u_form"  type="hidden" name="u_mdo" value="uploadFile">&nbsp;&nbsp;';
		$u_c.='<input class="u_form"  type="submit" name="" value="'.$ling["button"]["upload"].'"></form></td></tr>';
		$u_c.='</table>';
		$u_c.='</td></tr>';
		$u_c.='</table>';
}




function _u_uploadImg(){
//UPLOAD IMAGE
}

if($u_mdo=="uploadImg") {
		if($_FILES['file']['type']=="image/gif" || $_FILES['file']['type']=="image/jpeg" || $_FILES['file']['type']=="image/gif") {
			$uploaddir = $cf['dir']['images']."/";
			$uploadfile = $uploaddir.$username."_".$_FILES['file']['name'];
			if(!move_uploaded_file($_FILES['file']['tmp_name'], $uploadfile)) $u_err=$ling["msg"]["failimageupload"];
		else $u_messages=$ling["msg"]["imageuploaded"];
	}
		header("location:".$_SERVER['PHP_SELF']."?u_mdo=cMenu&u_a=".$u_a."&u_err=".$u_err."&u_messages=".$u_messages."&sid=".$sid."");
	}
	
function _u_uploadFile(){
//UPLOAD FILE
}

if($u_mdo=="uploadFile") {
	$uploaddir = $cf['dir']['files']."/";
	$uploadfile = $uploaddir.$username."_".$_FILES['file']['name'];
	if(right($_FILES['file']['name'],4)!=".php" && 	right($_FILES['file']['name'],4)!=".PHP" && 	right($_FILES['file']['name'],3)!=".pl" && 	right($_FILES['file']['name'],3)!=".PL" && 	right($_FILES['file']['name'],4)!=".cgi" && 	right($_FILES['file']['name'],4)!=".CGI" &&right($_FILES['file']['name'],5)!=".php3" && 	right($_FILES['file']['name'],5)!=".PHP3"){
		if(!move_uploaded_file($_FILES['file']['tmp_name'], $uploadfile)) $u_err=$ling["msg"]["failfileupload"];
	else $u_messages=$ling["msg"]["fileuploaded"];
		}
		header("location:".$_SERVER['PHP_SELF']."?u_mdo=cMenu&u_err=".$u_err."&u_messages=".$u_messages."&sid=".$sid."");
}
	// Delete File
if($u_mdo=="deleteFile") {
		if(!unlink($_POST["dfile"])) $u_err=$ling["msg"]["failfiledelete"];
		else $u_messages=$ling["msg"]["filedeleted"];
		header("location:".$_SERVER['PHP_SELF']."?u_mdo=cMenu&u_a=".$u_a."&u_err=".$u_err."&u_messages=".$u_messages."&sid=".$sid."");
}

}//end user accessible conditions



function __u_do_actions__(){

///////////////////////////////
// ACTIONS FOR ADMINS (u_do)
///////////////////////////////

}

// Config panel
if($sid&&$turboadmin==5) { //only for superadmin

function _u_modUsers(){
//USERS LIST
}

if($u_do=="modUsers") {
		$u_c='<div align="center"><H3 align="center">'.$ling["mod_multiuser"]["users_list"].'</H3>';
		$u_c.='<form name="form_users_search" id="form_users_search" action="" method="post">';
		$u_c.=$ling["search"]["button"].' : <input class="u_form" type="text" name="u_user_search">';
		$u_c.='<input class="u_form"  type="button" name="u_addUser" value="'.$ling["button"]["go"].'"  onClick="uHttpRequest(\'divcontent\',\''.$u_url.'?u_do=modUsers&sid='.$sid.'&xuledit=1\',\'form_users_search\')"></form><BR>';
		$u_c.='<a href="?u_do=modUsers&sid='.$sid.'&u_nomail=1">Users without email</a><BR>';
		$u_c.='<form name="form_users" id="form_users" action="" method="post">
		<input class="u_form"  type="hidden" id="u_do" name="u_do" value="">';
		$u_c.='<select class="u_form" name="u_user" id="u_user" size="20">';
		if(isset($_POST["u_user_search"]))
		$q=$db->get_results('select id,username,realname,permission from unak_users where username like "%'.$_POST["u_user_search"].'%" or realname like "%'.$_POST["u_user_search"].'%"');
		elseif(isset($_GET["u_nomail"]))
		$q=$db->get_results('select id,username,realname,permission from unak_users where email=""');
		else
		$q=$db->get_results('select id,username,realname,permission from unak_users');
		if($q){
		foreach($q as $row) {
			$u_name=split(",",$row->realname);
			$u_lname=$u_name[1];
			$u_fname=$u_name[0];
		if(!$row->permission) $permuser=$ling["mod_multiuser"]["users_user"];
		elseif($row->permission=="1") $permuser=$ling["mod_multiuser"]["users_moderator"];
		elseif($row->permission=="5") $permuser=$ling["mod_multiuser"]["users_superadmin"];
			$u_c.='<option value="'.$row->id.'">'.$u_lname.' '.$u_fname.' ('.$row->username.') '.$permuser.'</option>';
		}	
		}								
		$u_c.='</select><BR><BR><input class="u_form"  type="button" name="u_editUser" value="'.$ling["mod_multiuser"]["users_editinfo"].'"  onClick="javascript:if(document.getElementById(\'u_user\').value!=\'\') { document.getElementById(\'u_do\').value=\'u_editUser\';uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_users\')}else { alert(\'Please select an user\')}">&nbsp;
		<input class="u_form"  type="button" name="u_editUserPermission" value="'.$ling["mod_multiuser"]["users_editpermissions"].'"  onClick="javascript:if(document.getElementById(\'u_user\').value!=\'\') { document.getElementById(\'u_do\').value=\'u_editUserPermission\';uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_users\')} else { alert(\'Please select an user\')}">&nbsp;
		<input class="u_form"  type="button" name="u_deleteUser" value="'.$ling["button"]["delete"].'"  onClick="javascript:if(document.getElementById(\'u_user\').value!=\'\') {document.getElementById(\'u_do\').value=\'u_deleteUser\';if(confirm(\''.$ling['confirm']['action'].'\')) uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_users\');return false;} else { alert(\'Please select an user\')}">&nbsp;
		<input class="u_form"  type="button" name="u_addUser" value="'.$ling["mod_multiuser"]["users_addnew"].'"  onClick="javascript:document.getElementById(\'u_do\').value=\'u_addUser\';uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_users\')">
		<center><BR><a href="?u_do=createUserPages&sid='.$sid.'">Create user pages</a></center>
		</form>';
		$u_c.='<H3 align="center">Logged users</H3>';
		
		//LOGOUT USER BY SESSION
		if($_GET["u_act"]=="logout"&&$turboadmin==5)
		$db->query("delete from unak_sessions where id='".$_GET["userlogout"]."'");
		
		//LIST ACTIVE USER SESSIONS
		$hourpast=(time()-3600);
		$result=$db->get_results("select id,sess_data from unak_sessions");
		if(is_array($result) && count($result)) {
			foreach($result as $session){
			
			$sessdata=unserialize($session->sess_data);
			if(is_array($sessdata)) {
		        while(list($key,$val)=each($sessdata))  {
		        	 if(isset($sessdata[$key])) {
		        	 if($key=="timestamp"&&$val>$hourpast){	
		        		$u_c.="<a href='$u_url?sid=$sid&u_do=u_editUser&u_user=".$sessdata["user_id"]."'>".$sessdata["username"]."</A>";
		        		$u_c.=" from IP: ".$sessdata["userip"]." logged at:".date("Y-m-d h:i:s",$sessdata["timestamp"])."";
		        		if($sessdata["turboadmin"]==5)
		        		$u_c.=" Superuser <a href='$u_url?sid=$sid&u_do=modUsers&u_act=logout&userlogout=".$session->id."'>Logout</a>";
		        		else 
		        		$u_c.=" <a href='$u_url?sid=$sid&u_do=modUsers&u_act=logout&userlogout=".$session->id."'>Logout</a>";
		        		$u_c.="<BR>";
		        	 }
		        	if($key=="timestamp"&&$val<(time()-$cf["session"]["timeout"]))
		        	$db->query("delete from unak_sessions where id='".$session->id."'");
            		
          			}
        		}
			}
			}
		}
		$u_c.="</div>";
	}


function _u_modGroups(){
// GROUPS LIST
}
	if($u_do=="modGroups") {
		if(isset($_POST["u_group_search"]))
		$q=$db->get_results('select id,title from unak_groups where title like "%'.$_POST["u_group_search"].'%"');
		else
		$q=$db->get_results('select id,title from unak_groups');
		
		if(is_array($q)) {
			$u_c.='<div align="center"><H3 align="center">'.$ling["mod_multiuser"]["groups_list"].'</H3>';
			$u_c.='<form name="form_groups_search" id="form_groups_search" action="" method="post">';
		$u_c.=$ling["search"]["button"].' : <input class="u_form" type="text" name="u_group_search">';
		$u_c.='<input class="u_form"  type="button" name="searchgroup" value="'.$ling["button"]["go"].'"  onClick="uHttpRequest(\'divcontent\',\''.$u_url.'?u_do=modGroups&sid='.$sid.'&xuledit=1\',\'form_groups_search\')"></form><BR>';
			$u_c.='<form name="form_groups" id="form_groups" action="" method="post">
			<input class="u_form"  type="hidden" id="u_do" name="u_do" value="">';
			$u_c.='<select class="u_form" name="u_group" id="u_group" size="15">';
			foreach($q as $row) {
				$qsum=$db->get_var('select count(id) from unak_user_groups where group_id='.$row->id.'');
				$u_c.='<option value="'.$row->id.'">'.$row->title.' (id '.$row->id.', members '.$qsum.')</option>';
			}
			$u_c.='</select><BR><BR><input class="u_form"  type="button" name="u_editGroup" value="'.$ling["mod_multiuser"]["groups_info"].'"  onClick="javascript:if(document.getElementById(\'u_group\').value!=\'\') {document.getElementById(\'u_do\').value=\'u_editGroup\';uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_groups\')} else { alert(\'Please select a group\')}">&nbsp;
			<input class="u_form"  type="button" name="u_editGroupPermission" value="'.$ling["mod_multiuser"]["users_editpermissions"].'"  onClick="javascript:if(document.getElementById(\'u_group\').value!=\'\') {document.getElementById(\'u_do\').value=\'u_editGroupPermission\';uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_groups\')} else { alert(\'Please select a group\')}">&nbsp;
			<input class="u_form"  type="button" name="u_deleteGroup" value="'.$ling["button"]["delete"].'"  onClick="javascript:if(document.getElementById(\'u_group\').value!=\'\') {document.getElementById(\'u_do\').value=\'u_deleteGroup\';if(confirm(\''.$ling['confirm']['action'].'\')) uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_groups\');return false;} else { alert(\'Please select a group\')}">&nbsp;
			<input class="u_form"  type="button" name="u_addGroup" value="'.$ling["mod_multiuser"]["groups_addnew"].'"  onClick="javascript:document.getElementById(\'u_do\').value=\'u_addGroup\';uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'form_groups\')">';
			$u_c.='</div></form>';
		} else {
			$u_c.='<H3 align="center">'.$ling["mod_multiuser"]["groups_nogroups"].'</H3>';
			$u_c.='<a href="'.$u_url.'?u_do=u_addGroup&sid='.$sid.'" class="u_form">'.$ling["mod_multiuser"]["groups_addnew"].'</a>';
		}
	}

function _u_addUser(){
// ADD USER FORM
}

	if($u_do=="u_addUser"||$_POST["u_caddUser"]) {
		$regForm='<form name="add_user" id="add_user" action="'.$u_url.'?&sid='.$sid.'" method="post" enctype="multipart/form-data">
		<input type="hidden" name="u_caddUser" id="u_caddUser" value="1">
		<table align="center" cellpadding="1" cellspacing="1" border="0" class="u_form">
		<tr><td align="center" colspan="2"><H3 align="center">'.$ling["mod_multiuser"]["users_profile"].'</H3></td></tr>
		<tr><td align="right">'.$ling["mod_multiuser"]["users_username"].'(login)&nbsp;*</td><td><input class="u_form"  class="u_form" type="text" name="u_user" id="u_user"></td></tr>
		<tr><td align="right">'.$ling["mod_multiuser"]["users_email"].'&nbsp;*</td><td><input class="u_form"   class="u_form" type="text" name="u_email" id="u_email"></td></tr>';
	if($cf["mod_multiuser"]["mailpass"]) $regForm.='<tr><td colspan="2">'.$ling["mod_multiuser"]["users_emailsend"].'</td></tr>';
	else $regForm.='<tr><td align="right">'.$ling["mod_multiuser"]["users_password"].'&nbsp;*</td><td><input class="u_form"  type="password" name="u_pass" id="u_pass"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_passwordrepeat"].'&nbsp;*</td><td><input class="u_form"  type="password" name="u_rpass" id="u_rpass"></td></tr>';
	$regForm.='<tr><td align="right" valign="top">First Name</td><td> <input class="u_form"  type="text" name="u_rname_f"> </td></tr><tr><td align="right" valign="top">Family Name</td><td valign="top"> <input class="u_form"  type="text" name="u_rname_l"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_occupation"].'</td><td><input class="u_form"  type="text" name="u_occupation"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_website"].'</td><td><input class="u_form"  type="text" name="u_url"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_messenger"].'</td><td><input class="u_form"  type="text" name="u_messanger"></td></tr>
	<tr valign="top"><td align="right">'.$ling['versions']['comments'].'</td><td><textarea class="u_form" name="u_location" cols="50" rows="15">'.$q->location.'</textarea></td></tr>
	<tr><td align="right" valign="top">Pic</td><td>';	
	if(is_file("modules/multiuser/img/missinguser.jpg"))
	$regForm.='<img src="modules/multiuser/img/missinguser.jpg">';
	$regForm.='<BR><input type="file" name="pic" class="u_form"><BR>';
	$regForm.='</td></tr>
	
	<tr><td align="right" valign="top">'.$ling["mod_multiuser"]["users_permissions"].'</td><td>'.$ling["mod_multiuser"]["users_user"].'&nbsp;<input class="u_form"  type="radio" name="u_permission" value="0" checked >&nbsp;<BR>
			'.$ling["mod_multiuser"]["users_moderator"].'<input class="u_form"  type="radio" name="u_permission" value="1">&nbsp;<BR>
			'.$ling["mod_multiuser"]["users_superadmin"].'<input class="u_form"  type="radio" name="u_permission" value="5">
			</td></tr>
	<tr><td align="left" colspan="2">* '.$ling["mod_multiuser"]["users_requiredfields"].'</td></tr>
	<tr><td colspan="2" align="center">
	<input class="u_form"  type="button" name="u_register" value="'.$ling["button"]["save"].'" onclick="if(document.getElementById(\'u_user\').value!=\'\' && document.getElementById(\'u_email\').value!=\'\') { submit(\'add_user\')} else { alert(\'Please fill the required fields marked with *\')}">&nbsp;
	<input class="u_form"  type="button" name="reset" value="'.$ling["button"]["reset"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&u_do=modUsers&xuledit=1\')">
	</td></tr>
	</table>
	</form>';	
	if(!$_POST["u_caddUser"]) $u_c=$regForm;
	}

function _u_caddUser(){
// USER ADD REGISTER
}

if(isset($_POST["u_caddUser"])) {
	// Check the data
	$ok=true;		if(!field_validator($ling["mod_multiuser"]["users_username"],$_POST["u_user"],"alphanumeric_unders",$min_length="3")) { $u_c=$regForm; $ok=false; }
if(!field_validator($ling["mod_multiuser"]["users_email"],$_POST["u_email"],"email")) { $u_c=$regForm; $ok=false; }
	//Is there a password?
	if(!$cf["mod_multiuser"]["mailpass"]) {			if(!field_validator($ling["mod_multiuser"]["users_password"],$_POST["u_pass"],"string",$min_length="3")) { $u_c=$regForm; $ok=false; }
				if($_POST["u_pass"]!==$_POST["u_rpass"]) { 
					$u_messages=$ling["mod_multiuser"]["msg_passnotequal"];
					$u_c=$regForm;
					$ok=false; 
				}
			}
	if($ok) {
		$u=$db->get_var('select id from unak_users where username="'.$_POST["u_user"].'"');
		$m=$db->get_var('select id from unak_users where email="'.$_POST["u_email"].'"');
		
		if($cf["mod_multiuser"]["mailpass"])
		$pass=substr(md5(rand(1000,10000)),0,8);
		else $pass=$_POST["u_pass"];
			
	if($u===NULL && $m===NULL) { // no duplicate user names
				$new_uid=maxRow("unak_users");
				$db->query('insert into unak_users values('.$new_uid.',"'.$_POST["u_user"].'","'.md5($pass).'","'.urldecode(unicode_decode($_POST["u_rname_f"].','.$_POST["u_rname_l"].'')).'","'.$_POST["u_email"].'","'.urldecode(unicode_decode($_POST["u_location"])).'","'.$_POST["u_url"].'","'.$_POST["u_messanger"].'","'.urldecode(unicode_decode($_POST["u_occupation"])).'","'.$_POST["u_permission"].'","'.time().'","'.time().'")');
				
				$db->query('insert into unak_user_groups values('.maxRow("unak_user_groups").',"'.$new_uid.'","1")');
				
	// ADD USER PAGES
	if($cf["mod_multiuser"]["personalpage"]!="") {
	
	//add directories
	if(@is_dir($cf["unak"]["root"]."/users")) {
	mkdir($cf["unak"]["root"]."/users/".$_POST["u_user"]);
	mkdir($cf["unak"]["root"]."/users/".$_POST["u_user"]."/images");
	}

	//add user pages
	allLang();
	if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
		for($i=0;$i<$c;$i++) {
			if($lang["sync"][$i]) {
			if($cf["mod_multiuser"]["membersec"]!="") $sec=$cf["mod_multiuser"]["membersec"];
			else {
			$sec1=maxRow("unak_sections_".$lang["name"][$i]);
			$sec=($sec1-1);
			}
			$max_art=maxRow("unak_articles_".$lang["name"][$i]);
				$ordr=$db->get_var('select max(ordr) from unak_articles_'.$lang["name"][$i].' where section="'.($sec).'" and parent="0"')+1;
				$db->query('insert into unak_articles_'.$lang["name"][$i].' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($_POST["u_rname"],ENT_QUOTES).'","'.htmlspecialchars($_POST["u_user"],ENT_QUOTES).'","'.$sec.'","0","'.$_POST["u_user"].'","'.time().'","1","0","'.$_POST["u_rname"].' personal page","","","","","","'.time().'")');
				$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$new_uid.'","'.$max_art.'","'.$lang["name"][$i].'","5")');			
				}
			}
		} else {
			if($cf["mod_multiuser"]["membersec"]!="") $sec=$cf["mod_multiuser"]["membersec"];
			else {
			$sec1=maxRow("unak_sections_".$sl);
			$sec=($sec1-1);
			}
		$max_art=maxRow("unak_articles_".$sl);
		$ordr=$db->get_var('select max(ordr) from unak_articles_'.$sl.' where section="'.$sec.'" and parent="0"')+1;
		$db->query('insert into unak_articles_'.sl.' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars(urldecode(unicode_decode($_POST["u_rname"])),ENT_QUOTES).'","'.htmlspecialchars($_POST["u_user"],ENT_QUOTES).'","'.$sec.'","0","'.$_POST["u_user"].'","'.time().'","1","0","'.$_POST["u_rname"].' personal page","","","","","","'.time().'")');
		$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$new_uid.'","'.$max_art.'","'.$sl.'","5")');
		//$db->debug();
		}
	//Create index file in user directory	
		create_index($cf["unak"]["root"]."/users/".$_POST["u_user"]."/index.php",$max_art);
	
	} //end add pages
// Upload User Picture
if($_FILES['pic']['name']) {
if(right($_FILES['pic']['name'],4)==".jpg" || right($_FILES['pic']['name'],4)==".JPG") {
		$uploaddir =  $cf["unak"]["root"]."/users/".$_POST["u_user"]."/";
		$uploadfile = $uploaddir."pic_". $_POST["u_user"].right($_FILES['pic']['name'],4);
		$uploadfilemin = $uploaddir."thumb_".$_POST["u_user"].right($_FILES['pic']['name'],4);
		if(!move_uploaded_file($_FILES['pic']['tmp_name'], $uploadfile)) {		$u_messages.=$ling['msg']['failimageupload'];
		} else {
		chmod($uploadfile, 0644);
		$img = new img($uploadfile);
		$img->resize();
		$img->store($uploadfilemin);
		$u_messages.=$ling['msg']['imageuploaded'];
		}
	}
}
			$u_messages=$ling["mod_multiuser"]["msg_userregistered"];
//Mail password to user	
			if($cf["mod_multiuser"]["mailpass"]) {
					$to = $_POST["u_email"];
    				$from = $cf["admin"]["email"];
	    			$subject = $cf["site"]["title"].' registration details';
	    			$message = "Thanks for registering! Now you can connect on our website using \n username : ".$_POST["u_user"]."\n password: ".$pass."";
					unakmailer($from,$to,$subject,$message);
					$u_messages=$ling["mod_multiuser"]["msg_registermail"];
				}
				
			} else {
			$u_messages=$ling["mod_multiuser"]["msg_registerexist"];
			$u_c=$regForm;
			}
		} else {
		// Show form
		$u_c=$regForm;
		}
header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=u_editUser&u_user=".$new_uid."&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}

function _u_deleteUser(){
// DELETE USER
}

if($u_do=="u_deleteUser") {
	$username=$db->get_var('select username from unak_users where id="'.$_POST['u_user'].'"');
	$db->query('delete from unak_users where id='.$_POST['u_user'].'');
		
	$db->query('delete from unak_user_groups where user_id='.$_POST['u_user'].'');
	
	$db->query('delete from unak_section_permissions where user_id='.$_POST['u_user'].'');
	
	$db->query('delete from unak_page_permissions where user_id='.$_POST['u_user'].'');
	
	system("rm -rf users/".$username);
	
	$u_messages=$ling["mod_multiuser"]["msg_userdeleted"];
	header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=modUsers&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
}

function _u_editUser(){
// EDIT USER FORM AND USER ACTIVITY SPY
}


if($u_do=="u_editUser") {
	$edituser=$_REQUEST["u_user"];
	$q=$db->get_row('select * from unak_users where id="'.$edituser.'"');
	$u_name=split(",",$q->realname);
	$u_lname=$u_name[1];
	$u_fname=$u_name[0];
	$u_c='<form action="'.$_SERVER['PHP_SELF'].'?sid='.$sid.'" name="editusers" id="editusers" method="post" enctype="multipart/form-data">
	<table cellpadding="1" cellspacing="1" border="0" align="center">
	<tr><td align="center" colspan="2" style="height:30px"><H3>'.$ling["mod_multiuser"]["users_profile"].'</H3></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_username"].'</td><td>'.$q->username.' <a href="?sid='.$sid.'&login_as=1&u_user='.$q->username.'" target="_blank">Login as user</a></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_joined"].'</td><td>'.date("Y-M-d h:i:s",$q->joined).'</td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_lastconnected"].'</td><td>'.date("Y-M-d h:i:s",$q->lastconnection).'</td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_email"].'</td><td><input class="u_form"  type="text" name="u_email" value="'.$q->email.'"></td></tr>
	<tr><td align="right">First Name</td><td><input class="u_form"  type="text" name="u_realname_f" value="'.$u_fname.'"></td></tr>
	<tr><td align="right">Family Name</td><td><input class="u_form"  type="text" name="u_realname_l" value="'.$u_lname.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_occupation"].'</td><td><input class="u_form"  type="text" name="u_occupation" value="'.$q->occupation.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_website"].'</td><td><input class="u_form"  type="text" name="u_url" value="'.$q->url.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_messenger"].'</td><td><input class="u_form"  type="text" name="u_messanger" value="'.$q->messanger.'"></td></tr>
	<tr valign="top"><td align="right">'.$ling['versions']['comments'].'</td><td><textarea class="u_form" name="u_location" cols="50" rows="15">'.$q->location.'</textarea></td></tr>
	<tr><td align="right" valign="top">Pic</td><td>';	
	if(is_file("users/".$q->username."/thumb_".$q->username.".jpg"))
	$u_c.='<img src="users/'.$q->username.'/thumb_'.$q->username.'.jpg">';
	elseif(is_file("modules/multiuser/img/missinguser.jpg"))
	$u_c.='<img src="modules/multiuser/img/missinguser.jpg">';
	$u_c.='<BR><BR><input type="file" name="pic" class="u_form"><BR>';
	if(is_file("users/".$q->username."/thumb_".$q->username.".jpg"))
	$u_c.='Delete pic: <input type="checkbox" name="deletepic">';
	$u_c.='</td></tr>
	<tr><td align="center" colspan="2" style="height:30px">'.$ling["mod_multiuser"]["users_changepass"].'</td></tr>
	<tr><td class="type" align="right">'.$ling["mod_multiuser"]["users_newpassword"].'</td><td><input class="u_form"  type="password" name="u_pass" class="input_forms"></td></tr>
	<tr><td class="type" align="right">'.$ling["mod_multiuser"]["users_passwordrepeat"].'</td><td><input class="u_form"  type="password" name="u_rpass" class="input_forms"></td></tr>
	<tr><td align="center" colspan="2" style="height:20px"></td></tr>';
	if(!$q->permission) $permuser="selected";
	elseif($q->permission=="1") $permeditor="selected";
	elseif($q->permission=="5") $permgod="selected";	
	$u_c.='<tr><td align="right">'.$ling["mod_multiuser"]["users_permissions"].'</td><td><select class="u_form" name="u_permission"><option value="0" '.$permuser.'>'.$ling["mod_multiuser"]["users_user"].'</option><option value="1" '.$permeditor.'>'.$ling["mod_multiuser"]["users_moderator"].'</option><option value="5" '.$permgod.'>'.$ling["mod_multiuser"]["users_superadmin"].'</option></select></td></tr>
	<tr><td align="center" colspan="2" style="height:20px"></td></tr>';
	$qpage=$db->get_results('select * from unak_articles_'.$sl.' where author="'.$q->username.'"');
	if($qpage){
	$u_c.='<tr><td align="right">Personal page'.$ling["mod_multiuser"]["personal_page"].'</td><td><select class="u_form" name="u_perspage">';
	$userperspage=$db->get_var('select page_id from unak_page_permissions where user_id="'.$q->id.'" and permission="5" and lang="'.$sl.'"');
	foreach($qpage as $perspage){
		if($userperspage==$perspage->id) $selected=" selected"; else $selected="";
		$u_c.='<option value="'.$perspage->id.'" '.$selected.'>'.$perspage->title.'</option>';
	}	
	$u_c.='</td></tr>';
	}
	$u_c.='<tr><td colspan="2" align="center" style="height:40px">
	<input class="u_form"  type="submit" name="u_ceditUser" value="'.$ling["button"]["save"].'">&nbsp;
	<input class="u_form"  type="button" name="reset" value="'.$ling["button"]["reset"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=modUsers&sid='.$sid.'&xuledit=1\')"></td></tr>
	<input class="u_form"  type="hidden" name="u_user" value="'.$edituser.'">
	<input class="u_form"  type="hidden" name="u_username" value="'.$q->username.'">
	<input class="u_form"  type="hidden" name="u_do" value="u_ceditUser">
	</table>
	</form>';

function _u_editRoles(){
// ROLES
}	

	$groups=$db->get_results('select * from unak_user_groups where user_id='.$edituser.'');
	$roles=$db->get_results('select * from unak_roles');
	if($groups){
	$u_c.='
	<table cellpadding="1" cellspacing="1" border="0" align="center">
	<tr><td align="center" colspan="2"><H4>Groups and roles</H4></td></tr>';
	
	foreach($groups as $group) {
	$notingroup.='and id!="'.$group->group_id.'" ';
	$grouptitle=$db->get_var('select title from unak_groups where id='.$group->group_id.'');
	$u_c.='<tr><td>'.$grouptitle;
	$u_c.='</td><td>';
	$u_c.='<form action="'.$_SERVER['PHP_SELF'].'?u_a='.$u_a.'&sid='.$sid.'" name="editusergroups'.$group->id.'" id="editusergroups'.$group->id.'" method="post">
	<input type="hidden" name="rowid" value="'.$group->id.'">
	<input type="hidden" name="userid" value="'.$edituser.'">
	<select class="u_form" class="u_form" id="roleid" name="roleid">';
	$u_c.='<option value="0">Not assigned</option>';
		if($roles){
		foreach($roles as $role) {
		if($group->role_id==$role->id)
		$u_c.='<option value="'.$role->id.'" selected>'.$role->title.'</option>';
		else
		$u_c.='<option value="'.$role->id.'">'.$role->title.'</option>';
		}
		} //are there some roles
	$u_c.='</select>';
	$u_c.='<input class="u_form"  type="hidden" name="u_do" value="u_modifyGroupRole">';
	$u_c.='<input class="u_form" type="button" name="Modify" value="Modify" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'editusergroups'.$group->id.'\')"></form>';
	$u_c.='</td><td><a onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?sid='.$sid.'&u_do=u_delGroupRole&rowid='.$group->id.'&userid='.$edituser.'&xuledit=1\')" href="#">Delete</a></td></tr>';
	}
	$u_c.='</table></form>';
	}//are there some groups?
	
	if(!$notingroup)
	$allgroups=$db->get_results('select * from unak_groups');
	else
	$allgroups=$db->get_results('select * from unak_groups where 0=0 '.$notingroup.'');
	if($allgroups){
	$u_c.='<form action="#" name="addusergroups" id="addusergroups" method="post">
	<table cellpadding="1" cellspacing="1" border="0" align="center">
	<tr><td align="left"><H4>Groups</H4></td><td align="left"><H4>Roles</H4></td></tr>';
	
	$u_c.='<tr><td>';
	$u_c.='<select class="u_form" class="u_form" id="newgroup" name="newgroup">';
	$u_c.='<option value="0">Not assigned</option>';
		foreach($allgroups as $allgroup) {
		$u_c.='<option value="'.$allgroup->id.'">'.$allgroup->title.'</option>';
		}
	$u_c.='</select>';
	$u_c.='</td><td>';
	$u_c.='<select class="u_form" class="u_form" id="newrole" name="newrole">';
	$u_c.='<option value="0">Not assigned</option>';
		if($roles){
		foreach($roles as $role) {
		$u_c.='<option value="'.$role->id.'">'.$role->title.'</option>';
		}
		} //there are some roles
	$u_c.='</select>';
	$u_c.='<input class="u_form"  type="hidden" name="u_do" value="u_addGroupRole">';
	$u_c.='<input class="u_form"  type="hidden" name="userid" value="'.$edituser.'">';
	$u_c.='</td></tr>';
	$u_c.='<tr><td colspan="2" align="center"><input class="u_form" type="button" name="Add" value="Add group and role" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'addusergroups\')"></td></tr>';
	$u_c.='</table></form>';
	}
	if($_REQUEST["spydate"])
	$spydate=" and dte='".$_REQUEST['spydate']."'";
	if($_REQUEST["spyaction"])
	$spyaction=" and come_from like '%".$_REQUEST['spyaction']."%'";
	if($_POST["spysearch"]&& ($_REQUEST["spydate"]||$_REQUEST["spyaction"]||$_REQUEST["spyuser"]))
	$useractivity=$db->get_results("select * from unak_zloben_log where (u_type='0' or u_type='9' or u_type='8') and post_vars='".$q->username."' $spydate $spyaction order by dte, tme");
	else 
	$useractivity=$db->get_results("select * from unak_zloben_log where (u_type='0' or u_type='9' or u_type='8') and post_vars='".$q->username."' and dte='".date("Y-m-d",time())."' order by dte, tme");
	$u_c.="<form action='?u_do=u_editUser&sid=$sid' method='post'>";
	$u_c.="<table cellpadding='1' cellspacing='1' border='0' align='center'>";
	$u_c.="<tr><td align='center'><H4>User activity</H4></td></tr>";
	$u_c.="<tr><td align='center'>";
	$u_c.="<table border='0'><tr><td>";
	$u_c.="Date (YYYY-MM-DD) <input class='u_form' type='text' name='spydate' size='10'></td><td>";
	$u_c.="Action (edit, add) <input class='u_form' type='text' name='spyaction' size='10'></td><td>";
	$u_c.="<input class='u_form' type='hidden' name='u_user' value='$edituser'>";
	$u_c.="<input class='u_form' type='submit' name='spyuser' value='Search'></td></tr></table>";
	$u_c.="</td></tr><tr><td>";
	if($useractivity){
	foreach($useractivity as $useract){
		if($useract->u_type=="9") $u_c.="<B>".$useract->dte." ".$useract->tme."</B> Login from ".$useract->remote_ip."<BR>";
		if($useract->u_type=="8") $u_c.="<B>".$useract->dte." ".$useract->tme."</B> Logout from ".$useract->remote_ip."<BR>";
		if($useract->u_type=="0") $u_c.="<B>".$useract->dte." ".$useract->tme."</B> ".$useract->come_from." from ".$useract->remote_ip."<BR><blockquote>POST AND GET:".$useract->get_vars."</blockquote><BR>";
	}
	}
	$u_c.="</td></tr></table></form>";
}

function _u_ceditUser(){
// EDIT USER REGISTER
}


if($u_do=="u_ceditUser") {
	$ok=true;
	$pass=0;
	if(!empty($_POST["u_pass"]))
		if(!field_validator($ling["mod_multiuser"]["users_password"],$_POST["u_pass"],"string",$min_length="3")) $ok=false;
		else $pass=1;
	//if(!field_validator($ling["mod_multiuser"]["users_email"],$_POST["u_email"],"email")) $ok=false;
	if($_POST["u_pass"]!=$_POST["u_rpass"]) {
		$u_messages=$ling["mod_multiuser"]["msg_passnotequal"];
		$ok=false;
	}
	if($ok) {
		if($pass) $db->query('update unak_users set password="'.md5($_POST["u_pass"]).'", realname="'.urldecode(unicode_decode(trim($_POST["u_realname_f"].','.$_POST["u_realname_l"]))).'", email="'.$_POST["u_email"].'", location="'.urldecode(unicode_decode($_POST["u_location"])).'", url="'.$_POST["u_url"].'", messanger="'.$_POST["u_messanger"].'", occupation="'.urldecode(unicode_decode($_POST["u_occupation"])).'", permission="'.$_POST["u_permission"].'" where id="'.$_POST["u_user"].'"');
		else $db->query('update unak_users set realname="'.urldecode(unicode_decode($_POST["u_realname_f"].','.$_POST["u_realname_l"])).'", email="'.$_POST["u_email"].'", location="'.urldecode(unicode_decode($_POST["u_location"])).'", url="'.$_POST["u_url"].'", messanger="'.$_POST["u_messanger"].'", occupation="'.urldecode(unicode_decode($_POST["u_occupation"])).'", permission="'.$_POST["u_permission"].'" where id="'.$_POST["u_user"].'"');
		$personalpage=$db->get_var('select page_id from unak_page_permissions where user_id="'.$_POST["u_user"].'" and permissions="5"');
		//delete the personal pages
		$db->query('delete from unak_page_permissions where user_id="'.$_POST["u_user"].'" and permission="5"');
		//insert the personal page in all languages
		allLang();
		if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
		for($i=0;$i<$c;$i++) {
			if($lang["sync"][$i]) {
		$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$_POST["u_user"].'","'.$_POST["u_perspage"].'","'.$lang["name"][$i].'","5")');	
			}}}else {
			$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$_POST["u_user"].'","'.$_POST["u_perspage"].'","'.$sl.'","5")');	
			}
		$u_messages=$ling["mod_multiuser"]["msg_userupdated"];
// Upload User Picture
if($_FILES['pic']['name']) {
if(right($_FILES['pic']['name'],4)==".jpg" || right($_FILES['pic']['name'],4)==".JPG") {
		$uploaddir =  $cf["unak"]["root"]."/users/".$_POST["u_username"]."/";
		$uploadfile = $uploaddir."pic_". $_POST["u_username"].right($_FILES['pic']['name'],4);
		$uploadfilemin = $uploaddir."thumb_".$_POST["u_username"].right($_FILES['pic']['name'],4);
		if(!move_uploaded_file($_FILES['pic']['tmp_name'], $uploadfile)) {	
			$u_messages.=$uploadfile.$ling['msg']['failimageupload'];
		} else {
		chmod($uploadfile, 0644);
		$img = new img($uploadfile);
		$img->resize();
		$img->store($uploadfilemin);
		$u_messages.=$ling['msg']['imageuploaded'];
		}
	}
}
if($_POST["deletepic"]=="on") {	unlink($cf["unak"]["root"]."/users/".$_POST["u_username"]."/pic_".$_POST["u_username"].".jpg");
unlink($cf["unak"]["root"]."/users/".$_POST["u_username"]."/thumb_".$_POST["u_username"].".jpg");
}

header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=u_editUser&u_user=".$_POST["u_user"]."&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}
}


function _u_addGroup(){
// ADD GROUP FORM
}
	if($u_do=="u_addGroup") {
	$gt=$db->get_results('select * from unak_group_type');
	$users=$db->get_results('select id,username,realname from unak_users');
	$u_c='<form action="" name="group" id="group" method="post">
	<table cellpadding="1" cellspacing="1" border="0" align="center">
	<tr><td align="center" colspan="3" style="height:30px">
	<H3 align="center">'.$ling["mod_multiuser"]["groups_details"].'</H3>
	</td></tr>
	<tr><td>'.$ling["mod_multiuser"]["groups_name"].'&nbsp;</td>
	<td colspan=2><input class="u_form"  type="text"  name="u_title"></td>
	</tr><tr>
	<td>'.$ling["mod_multiuser"]["groups_type"].'&nbsp;</td>
	<td colspan=2><select class="u_form" name="u_type">';
	foreach($gt as $type) {
		$u_c.='<option value="'.$type->id.'">'.$type->u_type.'</option>';
	}
	$u_c.='</select></td></tr>
	<tr><td colspan=3 align="center"><BR><H4>'.$ling["mod_multiuser"]["groups_members"].'</H4></td></tr><tr>
	<td>'.$ling["mod_multiuser"]["groups_allusers"].'</td>
	<td>&nbsp;</td>
	<td>'.$ling["mod_multiuser"]["groups_members"].'</td></tr>
	<tr><td>
	<select class="u_form" multiple size="7" name="allusers">';
	foreach($users as $user) {
		$u_name=split(",",$user->realname);
		$u_lname=$u_name[1];
		$u_fname=$u_name[0];
		$u_c.='<option value="'.$user->id.'">'.$u_lname.' '.$u_fname.' ('.$user->username.')</option>';
	}
	$u_c.='</select></td>
	<td>
		<input class="u_form"  type=button value="&nbsp;->&nbsp;"  onclick="move(document.group.allusers,document.group.members)"><br>
		<input class="u_form"  type=button value="&nbsp;<-&nbsp;"  onclick="move(document.group.members,document.group.allusers)">
	</td>
	<td>
	<select class="u_form" multiple size="7"  name="members"></select>
	</td></tr>
	<tr align="center"><td colspan=3>'.$ling["mod_multiuser"]["groups_description"].'</td>
	</tr><tr>
	<td colspan="3" align="center">
	<textarea class="u_form"  name="u_description" cols="40" rows="5"></textarea>
	</td></tr><tr>
	<td colspan="3" align="center">
	<input class="u_form"  type="hidden" name="u_members" value="">
	<input class="u_form"  type="hidden" name="u_do" value="u_caddGroup">';
	
	// AJAX GROUP ADD
	$u_c.='<input class="u_form"  type="button"  name="u_caddGroup" value="'.$ling["button"]["save"].'" onclick="create_arr(document.group.members,document.group.u_members);uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'group\')">&nbsp;
	<input class="u_form"  type="button"  name="u_reset" value="'.$ling["button"]["cancel"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=modGroups&sid='.$sid.'&xuledit=1\')">';
	$u_c.='</td></tr>
	</table>
	</form>';
	}


function _u_caddGroup(){
// GROUP ADD REGISTER
}

if($u_do=="u_caddGroup") {
	$ok=true;
	if(!field_validator("Title",$_POST["u_title"],"string",$min_length="1",$max_length="255")) $ok=false;
	$members=explode(":",$_POST["u_members"]);
	array_pop($members);
	if($ok) { 
		$db->query('insert into unak_groups values('.maxRow("unak_groups").',"'.urldecode(unicode_decode($_POST["u_title"])).'","'.urldecode(unicode_decode($_POST["u_description"])).'","'.$_POST["u_type"].'")');
		foreach($members as $member) $db->query('insert into unak_user_groups values('.maxRow("unak_user_groups").','.$member.','.maxRow("unak_groups").')');

		$u_messages=$ling["mod_multiuser"]["msg_groupadded"];
		header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=modGroups&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}
}

function _u_editGroup(){
// EDIT GROUP FORM
}
if($u_do=="u_editGroup") {
	
	$group=$db->get_row('select * from unak_groups where id='.$_POST["u_group"]);
	$gt=$db->get_results('select * from unak_group_type');
	$users=$db->get_results('select id,realname,username from unak_users');
	$members=$db->get_results('select user_id from unak_user_groups where group_id='.$_POST["u_group"].'');
	$memberscount=count($members);
	$u_c='<form action="" name="group" id="group" method="post">
	<table cellpadding="0" cellspacing="0" border="0" align="center">
	<tr><td align="center" style="height:30px" colspan="2"><H3>'.$ling["mod_multiuser"]["groups_details"].'</H3></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["groups_name"].': </td><td><input class="u_form"   type="text" name="u_title" value="'.$group->title.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["groups_type"].': </td><td><select  class="u_form" name="u_type">';
	foreach($gt as $type) {
		
		$u_c.='<option  value="'.$type->id.'" ';
		if($group->u_type==$type->id) $u_c.='selected';
		$u_c.=' >'.$type->u_type.'</option>';
	}
	$u_c.='</select></td></tr>
	<tr><td align="center" style="height:30px" colspan="2">'.$ling["mod_multiusergroups"]["members"].'</td></tr>
	<tr><td colspan="2"><table cellpadding="0" cellspacing="0" border="0">';
	$u_c.='<tr><td align="center">'.$ling["mod_multiuser"]["groups_allusers"].'</td><td>&nbsp;</td><td align="center">'.$memberscount.' '.$ling["mod_multiuser"]["groups_membersof"].' '.$group->title.'</td></tr>';
	$u_c.='<tr><td valign="top"><select class="u_form" multiple size="7" name="allusers">';
	
	foreach($users as $user) {
		$inmember="out";
		if(is_array($members)){
		foreach($members as $member) {
			if($member->user_id==$user->id){
			$inmember="in";
			}
		}
		}
		if($inmember=="out"){
		$u_name=split(",",$user->realname);
		$u_lname=$u_name[1];
		$u_fname=$u_name[0];
		$u_c.='<option value="'.$user->id.'">'.$u_lname.' '.$u_fname.' ('.$user->username.')</option>';
		}
	}
	$u_c.='</select></td><td valign="middle">
	<input class="u_form"  type=button  value="&nbsp;->&nbsp;" onclick="move(document.group.allusers,document.group.members)"><br>
	<input class="u_form"  type=button  value="&nbsp;<-&nbsp;" onclick="move(document.group.members,document.group.allusers)"></td>
	<td valign="top"><select class="u_form" multiple size="7" name="members">';
	
	if(is_array($members))
	foreach($members as $member) { 
		$username=$db->get_row('select realname, username from unak_users where id='.$member->user_id.'');
		$u_name=split(",",$username->realname);
		$u_lname=$u_name[1];
		$u_fname=$u_name[0];
		$u_c.='<option  value="'.$member->user_id.'">'.$u_lname.' '.$u_fname.' ('.$username->username.')</option>';
	}
	$u_c.='</select></td></tr></table>
	<tr><td align="center" style="height:30px" colspan="2">'.$ling["mod_multiuser"]["groups_description"].'</td></tr>
	<tr><td colspan="2" align="center">
	<textarea class="u_form" name="u_description" cols="40" rows="5">'.$group->description.'</textarea></td></tr>
	<tr><td colspan="2" align="center">';
	
	// AJAX request
	$u_c.='<input class="u_form"   type="button" name="u_ceditGroup" value="'.$ling["button"]["save"].'" onclick="create_arr(document.group.members,document.group.u_members);uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'group\')">
	<input class="u_form" type="button" name="u_ceditGroup" value="'.$ling["button"]["cancel"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=modGroups&sid='.$sid.'&xuledit=1\')">';

	$u_c.='</td></tr></table>
	<input class="u_form"  type="hidden" name="u_members" value="">
	<input class="u_form"  type="hidden" name="u_group" value="'.$group->id.'">
	<input class="u_form"  type="hidden" name="u_do" value="u_ceditGroup">
	</form>';
}

function _u_ceditGroup(){
// EDIT GROUP REGISTER
}

if($u_do=="u_ceditGroup") {	
	$ok=true;
	if(!field_validator($ling['editor']['title'],$_POST["u_title"],"string",$min_length="1",$max_length="255")) $ok=false;
	$members=explode(":",$_POST["u_members"]);
	array_pop($members);
	if($ok) { 
		$db->query('update unak_groups set title="'.urldecode(unicode_decode($_POST["u_title"])).'",description="'.urldecode(unicode_decode($_POST["u_description"])).'",u_type="'.$_POST["u_type"].'" where id='.$_POST["u_group"].'');
		$db->query('delete from unak_user_groups where group_id='.$_POST["u_group"].'');
		foreach($members as $member) $db->query('insert into unak_user_groups values('.maxRow("unak_user_groups").','.$member.','.$_POST["u_group"].',"")');
		
		$u_messages=$ling["mod_multiuser"]["msg_groupedited"];	
		header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=modGroups&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}
}

function _u_deleteGroup(){
// DELETE GROUP
}


if($u_do=="u_deleteGroup") {	
	$db->query('delete from unak_groups where id='.$_POST["u_group"]);
	
	$db->query('delete from unak_user_groups where group_id='.$_POST["u_group"].'');
	
	$db->query('delete from unak_section_permissions where group_id='.$_POST["u_group"].'');
	
	$db->query('delete from unak_page_permissions where group_id='.$_POST["u_group"].'');
	$u_messages=$ling["mod_multiuser"]["msg_groupedeleted"];
	header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=modGroups&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
}



function _u_editUserPermission(){
// USER PERMISSIONS FORM
}

if($u_do=="u_editUserPermission") {	
	$u_c='<form action="" method="post" name="group" id="group">
	<table cellpadding="0" cellspacing="0" border="0" align="center">
	<tr><td align="center" colspan="3">';
	$uname=$db->get_var('select username from unak_users where id='.$_REQUEST["u_user"]);
	$u_c.='<H3 align="center">'.$ling["mod_multiuser"]["p_permissionsfor"].'&nbsp;<span style="color:red">'.$uname.'</span>,&nbsp;'.$ling["language"]["language"].'&nbsp;<span style="color:red">'.$sl.'</span></H3>';
	allLang();
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		if($sl!=$lang["name"][$i]) {
			$u_c.=$ling["mod_multiuser"]["p_permissionsfor"].' <a href="?u_do='.$u_do.'&u_user='.$_REQUEST["u_user"].'&u_s='.$u_s.'&u_a='.$u_a.'&sl='.$lang["name"][$i].'&sid='.$sid.'">';
			$u_c.='<img src="images/flags/'.$lang["name"][$i].'.gif" title="'.$lang["name"][$i].'" alt="'.$lang["name"][$i].'" border="0" valign="middle"></a><BR>';
		}
	}
	$u_c.='</td></tr>';
	$types=$db->get_results('select * from unak_permissions_type order by id asc');
	foreach($types as $type) {
		$ts[]=$type->u_type;
		$u_c.='<tr><td colspan="3" align="center">'.$ling['mod_multiuser'][$type->u_type].'</td></tr>
		<tr><td>'.$ling["mod_multiuser"]["p_contentavailable"].'</td>
		<td>&nbsp;</td>
		<td>'.$ling["mod_multiuser"]["p_contentpermited"].'</td></tr>
		<tr><td>
		<select class="u_form" multiple size="7" name="'.$type->u_type.'_content">';
		$csa=count($u_sa["id"]);
		$s_per=$db->get_results('select section_id from unak_section_permissions where user_id="'.$_REQUEST["u_user"].'" and lang="'.$sl.'" and permission="'.$type->id.'"');
		for($i=0;$i<$csa;$i++) {
		//filter groups in left select
		$ingroup="out";
		if(is_array($s_per)){
		foreach($s_per as $s_id) {
			if($s_id->section_id==$u_sa["id"][$i]){
			$ingroup="in";
			}
		}
		}
		//endfilter
		if($ingroup=="out"){
		if($type->id=="1"&&$u_sa["permissions"][$i]=="0")
		$u_c.='<option  value="s_'.$u_sa["id"][$i].'">'.$u_sa["title"][$i].'</option>';
		elseif($type->id>"1")
		$u_c.='<option  value="s_'.$u_sa["id"][$i].'">'.$u_sa["title"][$i].'</option>';
		}
		}
		$u_c.='</select></td>
		<td>
			<input class="u_form"   type=button name="s" value="&nbsp;->&nbsp;" onclick="move(document.group.'.$type->u_type.'_content,document.group.'.$type->u_type.'_permitted)"><br>
			<input class="u_form"   type=button name="s" value="&nbsp;<-&nbsp;" onclick="move(document.group.'.$type->u_type.'_permitted,document.group.'.$type->u_type.'_content)">
		</td>
		<td>
		<select class="u_form" multiple size="7" name="'.$type->u_type.'_permitted">';
		
		if(is_array($s_per))
		foreach($s_per as $s_id) { 
			$u_c.='<option  value="s_'.$u_sa["id"][$s_id->section_id].'">'.$u_sa["title"][$s_id->section_id].'</option>';
		}
		$u_c.='</select></td></tr> 
		<input class="u_form"  type="hidden" name="u_'.$type->u_type.'_permitted">';
	}
	$u_c.='<tr><td align="center" colspan="3"><input class="u_form"  type="hidden" name="u_user" value="'.$_REQUEST["u_user"].'">
	<input class="u_form"  type="hidden" name="u_do" value="u_ceditUserPermission">';
	// AJAX request
	$u_c.='<BR><input class="u_form"   type="button" name="u_ceditUserPermission" value="'.$ling["button"]["save"].'" onclick="'; foreach($ts as $t) $u_c.='create_arr(document.group.'.$t.'_permitted,document.group.u_'.$t.'_permitted); '; $u_c.='; uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'group\')">
	<input class="u_form" type="button" name="u_ceditUserPermission" value="'.$ling["button"]["cancel"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=modUsers&sid='.$sid.'&xuledit=1\')">';
	$u_c.='</td></tr>
	</table></form>';
}

function _u_ceditUserPermission(){
// USER PERMISSIONS REGISTER
}

if($u_do=="u_ceditUserPermission") {
	$types=$db->get_results('select * from unak_permissions_type');
	foreach($types as $type) {
		$permitted=explode(":",$_POST["u_".$type->u_type."_permitted"]);
		array_pop($permitted);
		$sp=array();
		$pp=array();
		$cp=count($permitted);		
		for($i=0;$i<$cp;$i++) {
			if(strpos($permitted[$i],"s_")!==false) $sp[]=str_replace("s_","",$permitted[$i]);
		//	elseif(strpos($permitted[$i],"a_")!==false) $ap[]=str_replace("s_","",$permitted[$i]);
		}
		$db->query('delete from unak_section_permissions where user_id='.$_POST["u_user"].' and lang="'.$sl.'" and permission='.$type->id.'');
		
		foreach($sp as $s) {
		$db->query('insert into unak_section_permissions (id,user_id,section_id,lang,permission) values('.maxRow("unak_section_permissions").','.$_REQUEST["u_user"].','.$s.',"'.$sl.'",'.$type->id.')');
		}
		
		$u_messages=$ling["mod_multiuser"]["p_userpermsaved"];
		header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=modUsers&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}
}

function _u_editGroupPermission(){
// GROUP PERMISSIONS FORM
}

if($u_do=="u_editGroupPermission") {
	$u_c='<form action="" method="post" name="group" id="group">
	<table cellpadding="0" cellspacing="0" border="0" align="center">';
	$gname=$db->get_var('select title from unak_groups where id='.$_REQUEST["u_group"]);
	$u_c.='<tr><td align="center" style="height:30px"><H3>'.$ling["mod_multiuser"]["p_permissionsfor"].' '.$gname.'</H3></td></tr>';
	$u_c.='<tr><td align="center" style="height:30px">';
	$u_c.=$ling["mod_multiuser"]["p_permissionsapply"].' '.$sl.' '.$ling["language"]["language"].'<br>';
	allLang();
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		if($sl!=$lang["name"][$i]) {
			$u_c.=$ling["mod_multiuser"]["p_permissionsfor"].' <a href="?u_do='.$u_do.'&u_group='.$_REQUEST["u_group"].'&u_s='.$u_s.'&u_a='.$u_a.'&sl='.$lang["name"][$i].'&sid='.$sid.'">';
			$u_c.='<img src="images/flags/'.$lang["name"][$i].'.gif" alt="'.$lang["name"][$i].'" border="0"></a> <BR>';
		}
	}
	$u_c.='</td></tr>';
	$types=$db->get_results('select * from unak_permissions_type');
	foreach($types as $type) {
		$ts[]=$type->u_type;
		$u_c.='<tr><td align="center"><P>'.$ling['mod_multiuser'][$type->u_type].'</P></td></tr>
		<tr><td>
		<table align="center" cellpadding="0" cellspacing="0" border="0">';
		$u_c.='<tr><td align="center">'.$ling["mod_multiuser"]["p_contentavailable"].'</td><td>&nbsp;</td><td align="center">'.$ling["mod_multiuser"]["p_contentpermited"].'</td></tr>';
		$u_c.='<tr><td valign="top"><select class="u_form" multiple size="7" name="'.$type->u_type.'_content">';
		$csa=count($u_sa["id"]);
		$s_per=$db->get_results('select section_id from unak_section_permissions where group_id="'.$_REQUEST["u_group"].'" and lang="'.$sl.'" and permission="'.$type->id.'"');
		for($i=0;$i<$csa;$i++) {
		$ingroup="out";
		if(is_array($s_per)){
		foreach($s_per as $s_id) {
			if($s_id->section_id==$u_sa["id"][$i]){
			$ingroup="in";
			}
		}
		}
		if($ingroup=="out"){
		if($type->id=="1"&&($u_sa["permissions"][$i]=="0"||$u_sa["permissions"][$i]=="2"))
		$u_c.='<option  value="s_'.$u_sa["id"][$i].'">'.$u_sa["title"][$i].'</option>';
		elseif($type->id>="2")
		$u_c.='<option  value="s_'.$u_sa["id"][$i].'">'.$u_sa["title"][$i].'</option>';
		}
		}
		$u_c.='</select></td><td valign="middle">
		<input class="u_form"   type=button value="&nbsp;->&nbsp;" onclick="move(document.group.'.$type->u_type.'_content,document.group.'.$type->u_type.'_permitted)"><br>
		<input class="u_form"   type=button value="&nbsp;<-&nbsp;" onclick="move(document.group.'.$type->u_type.'_permitted,document.group.'.$type->u_type.'_content)"></td>
		<td valign="top"><select  class="u_form" multiple size="7" name="'.$type->u_type.'_permitted">';
		
		if(is_array($s_per))
		foreach($s_per as $s_id) { 
			$u_c.='<option  value="s_'.$u_sa["id"][$s_id->section_id].'">'.$u_sa["title"][$s_id->section_id].'</option>';
		}
		$u_c.='</select>
		<input class="u_form"  type="hidden" name="u_'.$type->u_type.'_permitted">
		</td></tr></table>';
	}
	$u_c.='<input class="u_form"  type="hidden" name="u_group" value="'.$_REQUEST["u_group"].'">
	<center>';
	// AJAX request
	$u_c.='<BR><input class="u_form"   type="button" name="u_ceditUserPermission" value="'.$ling["button"]["save"].'" onclick="'; foreach($ts as $t) $u_c.='create_arr(document.group.'.$t.'_permitted,document.group.u_'.$t.'_permitted); '; $u_c.='; uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'group\')">
	<input class="u_form" type="button" name="u_ceditUserPermission" value="'.$ling["button"]["cancel"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=modGroups&sid='.$sid.'&xuledit=1\')">';
	$u_c.='<input class="u_form"  type="hidden" name="u_do" value="u_ceditGroupPermission">
	</td></tr></table></form>';
}


function _u_ceditGroupPermission(){
// GROUP PERMISSIONS REGISTER
}


if($u_do=="u_ceditGroupPermission") {
	$types=$db->get_results('select * from unak_permissions_type');
	foreach($types as $type) {
		$permitted=explode(":",$_POST["u_".$type->u_type."_permitted"]);
		array_pop($permitted);
		$sp=array();
		$pp=array();
		$cp=count($permitted);		
		for($i=0;$i<$cp;$i++) {
			if(strpos($permitted[$i],"s_")!==false) $sp[]=str_replace("s_","",$permitted[$i]);
			//elseif(strpos($permitted[$i],"a_")!==false) $ap[]=str_replace("s_","",$permitted[$i]);
		}
		$db->query('delete from unak_section_permissions where group_id='.$_POST["u_group"].' and lang="'.$sl.'" and permission='.$type->id.'');
		
		foreach($sp as $s) $db->query('insert into unak_section_permissions (id,group_id,section_id,lang,permission) values('.maxRow("unak_section_permissions").','.$_REQUEST["u_group"].','.$s.',"'.$sl.'",'.$type->id.')');
	
$u_messages=$ling["mod_multiuser"]["p_grouppermsaved"];
		header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=modGroups&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}
}



function _u_pageUserPermission(){
// PAGE USER PERMISSIONS FORM
}

if($u_do=="pageUserPermission") {
	getUsers();
	$u_c='<form action="" method="post" name="group" id="group">';
	$pname=$db->get_var('select title from unak_articles_'.$sl.' where id='.$u_a);
	$u_c.='<table cellpadding="0" cellspacing="0" border="0" align="center"><tr><td>
	<H3 align="center">'.$ling["mod_multiuser"]["p_permissionsuserpage"].'&nbsp;<span style="color:red">'.$pname.'</span></H3></td></tr>';
	
	$u_c.='<tr><td align="center">'.$ling["mod_multiuser"]["p_permissionsapply"].' '.$ling["language"]["language"].' <B>'.$sl.'</B></td></tr>';
	
	$u_c.='<tr><td align="center"><BR>';
	allLang();
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		if($sl!=$lang["name"][$i]) {
			$u_c.=$ling["mod_multiuser"]["p_permissionsfor"].'&nbsp;<a href="?u_do='.$u_do.'&u_s='.$u_s.'&u_a='.$u_a.'&sl='.$lang["name"][$i].'&sid='.$sid.'">';
			$u_c.='<img src="images/flags/'.$lang["name"][$i].'.gif" title="'.$lang["name"][$i].'" alt="'.$lang["name"][$i].'" border="0" align="middle" valign="middle"></a> <BR>';
		}
	}
	$u_c.='</td></tr>';
	$u_c.='<tr><td align="center"><a href="?u_s='.$u_s.'&u_a='.$u_a.'&u_do=pageGroupPermission&sid='.$sid.'">'.$ling["mod_multiuser"]["p_permissionsgroup"].'</td></tr><tr><td align="center">';
	
	$types=array();
	if($u_ac["permissions"]<2) 
	$types=$db->get_results('select * from unak_permissions_type where id>="2"');
	else
	$types=$db->get_results('select * from unak_permissions_type');
	
	foreach($types as $type) {
		$ts[]=$type->u_type;
		
		$u_c.='<p>'.$ling['mod_multiuser'][$type->u_type].'</p></td></tr><tr><td align="center">
		<table align="center" cellpadding="0" cellspacing="0" border="0">
		<tr>
		<td align="center">'.$ling["mod_multiuser"]["p_usersavailable"].'</td>
		<td>&nbsp;</td>
		<td align="center"> '.$ling["mod_multiuser"]["p_usersallowed"].'</td>
		</tr>
		<tr><td>
		<select class="u_form"  multiple size="7" name="'.$type->u_type.'_content">';
		$csa=count($u_ua["id"]);
		$u_per=$db->get_results('select user_id from unak_page_permissions where page_id="'.$u_a.'" and lang="'.$sl.'" and user_id IS NOT NULL and permission="'.$type->id.'"');
		for($i=0;$i<$csa;$i++) {
		//filter pages in left select
		$inpage="out";
		if(is_array($u_per)){
		foreach($u_per as $u_id) {
			if($u_id->user_id==$u_ua["id"][$i]){
			$inpage="in";
			}
		}
		}
		//endfilter
		if($inpage=="out"){
			if($u_ua["realname"][$i]) $user_realname='('.$u_ua["realname"][$i].')';
			else $user_realname='';
			if($u_ua["permission"][$i]!=5) $u_c.='<option value="g_'.$u_ua["id"][$i].'">'.$u_ua["username"][$i].' '.$user_realname.'</option>';
		}
		}//ednfor
		$u_c.='</select></td>
		<td>
			<input class="u_form"  type=button name="s"  value="&nbsp;->&nbsp;" onclick="move(document.group.'.$type->u_type.'_content,document.group.'.$type->u_type.'_permitted)"><br>
			<input class="u_form"  type=button name="s"  value="&nbsp;<-&nbsp;" onclick="move(document.group.'.$type->u_type.'_permitted,document.group.'.$type->u_type.'_content)">
		</td>
		<td>
		<select class="u_form" multiple size="7" name="'.$type->u_type.'_permitted">';
		
		if(is_array($u_per))
		foreach($u_per as $u_id) { 
			$user_key=array_search($u_id->user_id,$u_ua["id"]);
			if($u_ua["realname"][$user_key]) $user_realn='('.$u_ua["realname"][$user_key].')';
			else $user_realn='';
			$u_c.='<option value="g_'.$u_id->user_id.'">'.$u_ua["username"][$user_key].' '.$user_realn.'</option>';
		}
		$u_c.='</select></td></tr></table>
		<input class="u_form"  type="hidden" name="u_'.$type->u_type.'_permitted">';
	}
	$u_c.='<input class="u_form"  type="hidden" name="u_do" value="cpageUserPermission">
	</td></tr><tr><td align="center">';
		// AJAX request
	$u_c.='<BR><input class="u_form"   type="button" name="u_ceditUserPermission" value="'.$ling["button"]["save"].'" onclick="'; foreach($ts as $t) $u_c.='create_arr(document.group.'.$t.'_permitted,document.group.u_'.$t.'_permitted); '; $u_c.='; uHttpRequest(\'divcontent\',\''.$u_url.'?&u_a='.$u_a.'&sid='.$sid.'&xuledit=1\',\'group\')">
	<input class="u_form" type="button" name="u_ceditUserPermission" value="'.$ling["button"]["cancel"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=editA&u_a='.$u_a.'&sid='.$sid.'&xuledit=1\')">';
	
	$u_c.='
		</td></tr></table>
	</form>';
}

function _u_cpageUserPermission(){
// PAGE USER PERMISSIONS REGISTER
}

if($u_do=="cpageUserPermission") {
	$types=$db->get_results('select * from unak_permissions_type');
	foreach($types as $type) {
		$permitted=explode(":",$_POST["u_".$type->u_type."_permitted"]);
		array_pop($permitted);
		$up=array();
		$pp=array();
		$cp=count($permitted);		
		for($i=0;$i<$cp;$i++) {
			if(strpos($permitted[$i],"g_")!==false) $up[]=str_replace("g_","",$permitted[$i]);
		}
		$db->query('delete from unak_page_permissions where page_id="'.$u_a.'" and user_id IS NOT NULL and lang="'.$sl.'" and permission='.$type->id.'');
		// update_id("unak_page_permissions");
		foreach($up as $u) $db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$u.'","'.$u_a.'","'.$sl.'","'.$type->id.'")');
		$u_messages=$ling["mod_multiuser"]["p_userpermsaved"];
		header("location:".$_SERVER['PHP_SELF']."?u_s=".$u_s."&u_a=".$u_a."&u_do=pageUserPermission&xuledit=1&u_messages=".urlencode($u_messages)."&sid=".$sid."");
	}
}

function _u_pageGroupPermission(){
// PAGE GROUP PERMISSIONS FORM
}

if($u_do=="pageGroupPermission") {
	getGroups();
	$u_c='<form action="" method="post" name="group" id="group">
	<table cellpadding="0" cellspacing="0" border="0" align="center">';
	$pname=$db->get_var('select title from unak_articles_'.$sl.' where id='.$u_a);
	$u_c.='<tr><td align="center" style="height:30px"><H3>'.$ling["mod_multiuser"]["p_permissionsgrouppage"].' <B>'.$pname.'</B></H3></td></tr>';
	$u_c.='<tr><td align="center" style="height:30px">';
	$u_c.=$ling["mod_multiuser"]["p_permissionsapply"].' '.$ling["language"]["language"].' <B>'.$sl.'</B><br>';
	allLang();
	$c=count($lang["name"]);
	for($i=0;$i<$c;$i++) {
		if($sl!=$lang["name"][$i]) {
			$u_c.=$ling["mod_multiuser"]["p_permissionsfor"].' <a href="?u_do='.$u_do.'&u_s='.$u_s.'&u_a='.$u_a.'&sl='.$lang["name"][$i].'&sid='.$sid.'">';
			$u_c.='<img src="images/flags/'.$lang["name"][$i].'.gif" alt="'.$lang["name"][$i].'" border="0"></a> <BR>';
		}
	}
	$u_c.='</td></tr>';
	$u_c.='<tr><td align="center"><BR><a href="?u_s='.$u_s.'&u_a='.$u_a.'&u_do=pageUserPermission&sid='.$sid.'">'.$ling["mod_multiuser"]["p_userpermissions"].'</a><BR></td></tr>';
	
	$types=array();
	if($u_ac["permissions"]<2) 
	$types=$db->get_results('select * from unak_permissions_type where id>="2"');
	else
	$types=$db->get_results('select * from unak_permissions_type');
	
	foreach($types as $type) {
		$ts[]=$type->u_type;
		$u_c.='<tr><td align="center"><P>'.$ling['mod_multiuser'][$type->u_type].'</P></td></tr>
		<tr><td>
		<table align="center" cellpadding="0" cellspacing="0" border="0">';
		$u_c.='<tr><td align="center">'.$ling["mod_multiuser"]["p_groupsavailable"].'</td><td>&nbsp;</td><td align="center">'.$ling["mod_multiuser"]["p_groupsallowed"].'</td></tr>';
		$u_c.='<tr><td valign="top"><select class="u_form" multiple size="7" name="'.$type->u_type.'_content">';
		$csa=count($u_ga["id"]);
		$g_per=$db->get_results('select group_id from unak_page_permissions where page_id="'.$u_a.'" and lang="'.$sl.'" and group_id IS NOT NULL and permission="'.$type->id.'"');
		for($i=0;$i<$csa;$i++) {
			//filter groups in left select
		$ingroup="out";
		if(is_array($g_per)){
		foreach($g_per as $g_id) {
			if($g_id->group_id==$u_ga["id"][$i]){
			$ingroup="in";
			}
		}
		}
			if($ingroup=="out")
			$u_c.='<option value="g_'.$u_ga["id"][$i].'">'.$u_ga["title"][$i].'</option>';
		}
		
		$u_c.='</select></td><td valign="middle">
		<input class="u_form"  type=button  value="&nbsp;->&nbsp;" onclick="move(document.group.'.$type->u_type.'_content,document.group.'.$type->u_type.'_permitted)"><br>
		<input class="u_form"  type=button  value="&nbsp;<-&nbsp;" onclick="move(document.group.'.$type->u_type.'_permitted,document.group.'.$type->u_type.'_content)">&nbsp;</td>
		<td valign="top"><select class="u_form" multiple size="7" name="'.$type->u_type.'_permitted">';
		if(is_array($g_per))
		foreach($g_per as $g_id) {
		$group_key=array_search($g_id->group_id,$u_ga["id"]);
			$u_c.='<option value="g_'.$g_id->group_id.'">'.$u_ga["title"][$group_key].'</option>';
		}
		$u_c.='</select>
		<input class="u_form"  type="hidden" name="u_'.$type->u_type.'_permitted">
		</td></tr></table>';
	}
	$u_c.='<input class="u_form"  type="hidden" name="u_do" value="cpageGroupPermission">
	<div align="center">';
	// AJAX request
	$u_c.='<BR><input class="u_form"   type="button" name="u_ceditUserPermission" value="'.$ling["button"]["save"].'" onclick="'; foreach($ts as $t) $u_c.='create_arr(document.group.'.$t.'_permitted,document.group.u_'.$t.'_permitted); '; $u_c.='; uHttpRequest(\'divcontent\',\''.$u_url.'?u_a='.$u_a.'&sid='.$sid.'&xuledit=1\',\'group\')">
	<input class="u_form" type="button" name="u_ceditUserPermission" value="'.$ling["button"]["cancel"].'" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&u_do=editA&u_a='.$u_a.'&sid='.$sid.'&xuledit=1\')">';
	$u_c.='</div>
		</td>
	</tr>
	</table>
	</form>';
}


function _u_cpageGroupPermission(){
// PAGE GROUP PERMISSIONS REGISTER
}

if($u_do=="cpageGroupPermission") {
	getGroups();
	$types=$db->get_results('select * from unak_permissions_type');
	foreach($types as $type) {
		$permitted=explode(":",$_POST["u_".$type->u_type."_permitted"]);
		array_pop($permitted);
		$gp=array();
		$pp=array();
		$cp=count($permitted);		
		for($i=0;$i<$cp;$i++) {
			if(strpos($permitted[$i],"g_")!==false) $gp[]=str_replace("g_","",$permitted[$i]);
		}
		$db->query('delete from unak_page_permissions where page_id='.$u_a.' and group_id IS NOT NULL and lang="'.$sl.'" and permission='.$type->id.'');
		
		foreach($gp as $g) $db->query('insert into unak_page_permissions (id,group_id,page_id,lang,permission) values('.maxRow("unak_page_permissions").','.$g.','.$u_a.',"'.$sl.'",'.$type->id.')');
		
		$u_messages=$ling["mod_multiuser"]["p_grouppermsaved"];
		header("location:".$_SERVER['PHP_SELF']."?u_s=".$u_s."&u_a=".$u_a."&u_do=pageGroupPermission&xuledit=1&u_messages=".urlencode($ling["mod_multiuser"]["p_grouppermsaved"])."&sid=".$sid."");
	}
}


function _u_modifyGroupRole(){
// MODIFY GROUP ROLE
}

if($u_do=="u_modifyGroupRole") {
if($_POST["rowid"])
$db->query('update unak_user_groups set role_id="'.$_POST["roleid"].'" where id="'.$_POST["rowid"].'"');
header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=u_editUser&u_user=".$_POST["userid"]."&xuledit=1&sid=".$sid."");
}

function _u_addGroupRole(){
// ADD GROUP ROLE
}

if($u_do=="u_addGroupRole") {
if($_POST["newgroup"])
$db->query('insert into unak_user_groups values('.maxRow("unak_user_groups").',"'.$_POST["userid"].'","'.$_POST["newgroup"].'","'.$_POST["newrole"].'")');
header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=u_editUser&u_user=".$_POST["userid"]."&xuledit=1&sid=".$sid."");
}

function _u_delGroupRole(){
// DELETE GROUP ROLE
}

if($u_do=="u_delGroupRole"&&$_GET["rowid"]) {	
$db->query('delete from unak_user_groups where id="'.$_GET['rowid'].'"');
header("location:".$_SERVER['PHP_SELF']."?u_a=".$u_a."&u_do=u_editUser&u_user=".$_REQUEST["userid"]."&xuledit=1&sid=".$sid."");
}

//END U_DO CONDITIONS

} //superadmin only



//SESSION RESTRICTED 

function __profile__(){
//////////////////////////
// Profile management
//////////////////////////
}

if($sid){

function _u_myprofile(){
//////////////////////////
// Profile management
//////////////////////////
}

if(isset($_GET["u_myprofile"]) || isset($_POST["u_myprofile"])) {
	$q=$db->get_row('select * from unak_users where id="'.$_GET["u_user"].'"');
	$u_name=split(",",$q->realname);
	$u_lname=$u_name[1];
	$u_fname=$u_name[0];
	$editForm='<form name="profile" id="profile" action="'.$u_url.'?&sid='.$sid.'" method="post" enctype="multipart/form-data">
	<table cellpadding="1" cellspacing="1" border="0">
	<tr><td align="center" colspan="2" style="height:30px"><H3>'.$ling["mod_multiuser"]["users_userinfo"].'</H3></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_username"].'</td><td>'.$q->username.'</td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_email"].'</td><td><input class="u_form"  type="text"  name="u_email" value="'.$q->email.'"></td></tr>
	<tr><td align="right">First Name</td><td><input class="u_form"  type="text"  name="u_realname_f" value="'.$u_fname.'"></td></tr>
	<tr><td align="right">Last Name</td><td><input class="u_form"  type="text"  name="u_realname_l" value="'.$u_lname.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_occupation"].'</td><td><input class="u_form"  type="text"  name="u_occupation" value="'.$q->occupation.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_website"].'</td><td><input class="u_form"  type="text"  name="u_url" value="'.$q->url.'"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_messenger"].'</td><td><input class="u_form"  type="text"  name="u_messanger" value="'.$q->messanger.'"></td></tr>
	<tr valign="top"><td align="right">'.$ling['versions']['comments'].'</td><td><textarea class="u_form" name="u_location" cols="50" rows="15">'.$q->location.'</textarea></td></tr>
	<tr><td align="right" valign="top">Pic</td><td>';	
	if(is_file("users/".$q->username."/thumb_".$q->username.".jpg"))
	$editForm.='<img src="users/'.$q->username.'/thumb_'.$q->username.'.jpg">';
	elseif(is_file("modules/multiuser/img/missinguser.jpg"))
	$editForm.='<img src="modules/multiuser/img/missinguser.jpg">';
	$editForm.='<BR><BR><input type="file" name="pic" class="u_form"><BR>';
	if(is_file("users/".$q->username."/thumb_".$q->username.".jpg"))
	$editForm.='Delete pic: <input type="checkbox" name="deletepic">';
	$editForm.='</td></tr>
	<tr><td colspan="2" align="center" style="height:40px">
	<input class="u_form"  type="submit"  name="u_myprofile" value="'.$ling["button"]["save"].'">&nbsp;<input class="u_form"  type="submit"  name="u_reset" value="'.$ling["button"]["cancel"].'"></td></tr>
	<tr><td align="center" colspan="2" style="height:30px">'.$ling["mod_multiuser"]["users_changepass"].'</td></tr>
	<tr><td class="type" align="right">'.$ling["mod_multiuser"]["users_newpassword"].'</td><td><input class="u_form"  type="password"  name="u_pass" class="input_forms"></td></tr>
	<tr><td class="type" align="right">'.$ling["mod_multiuser"]["users_passwordrepeat"].'</td><td><input class="u_form"  type="password"  name="u_passr" class="input_forms"></td></tr>
	<tr><td align="center" colspan="2" style="height:20px"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_joined"].'</td><td>'.date("Y-M-d h:i:s",$q->joined).'</td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_lastconnected"].'</td><td>'.date("Y-M-d h:i:s",$q->lastconnection).'</td></tr>	
	<tr><td colspan="2" align="center" style="height:40px">
	<input class="u_form"  type="submit"  name="u_myprofile" value="'.$ling["button"]["save"].'" onclick = "if(profile.u_pass.value.length>0) {profile.u_passmd.value=hex_md5(profile.u_pass.value);profile.u_passmdr.value=hex_md5(profile.u_passr.value);profile.u_pass.value=\'hidepass\';profile.u_passr.value=\'hidepass\';submit(profile);}">&nbsp;<input class="u_form"  type="submit"  name="u_reset" value="'.$ling["button"]["cancel"].'"></td></tr>
	<input class="u_form"  type="hidden" name="u_user" value="'.$_GET["u_user"].'">
	<input class="u_form"  type="hidden" name="u_myprofile" value="">
	<input class="u_form"  type="hidden" name="u_cmyprofile" value="">
	<input class="u_form"  type="hidden" name="u_passmd" value="">
	<input class="u_form"  type="hidden" name="u_passmdr" value="">
	<input class="u_form"  type="hidden" name="u_username" value="'.$q->username.'">
	</table>
	</form>';
	
	$groups=$db->get_results('select uug.group_id as group_id, uug.id as id from unak_user_groups uug, unak_groups ug where uug.user_id="'.$_GET["u_user"].'" and uug.group_id=ug.id and ug.u_type="0"');
	
	
	if($groups){
	$editForm.='
	<table cellpadding="1" cellspacing="1" border="0" align="center">
	<tr><td align="center" colspan="2"><H4>Groups</H4></td></tr>';
	
	foreach($groups as $group) {
	$notingroup.='and id!="'.$group->group_id.'" ';
	$grouptitle=$db->get_var('select title from unak_groups where id='.$group->group_id.'');
	$editForm.='<tr><td>'.$grouptitle;
	$editForm.='</td><td><a onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?sid='.$sid.'&u_mdo=u_delGroupProfile&rowid='.$group->id.'&userid='.$_GET["u_user"].'&xuledit=1\')" href="#">Delete</a></td></tr>';
	}
	$editForm.='</table></form>';
	}//are there some groups?
	
	if(!$notingroup)
	$allgroups=$db->get_results('select * from unak_groups where u_type="0"');	
	else
	$allgroups=$db->get_results('select * from unak_groups where u_type="0" '.$notingroup.'');
	
	if($allgroups){
	$editForm.='<form action="#" name="addusergroups" id="addusergroups" method="post">
	<table cellpadding="1" cellspacing="1" border="0" align="center">
	<tr><td align="left" colspan="2"><H4>Groups</H4></td></tr>';
	
	$editForm.='<tr><td>';
	$editForm.='<select class="u_form" id="newgroup" name="newgroup">';
	$editForm.='<option value="">Not assigned</option>';
		foreach($allgroups as $allgroup) {
			$editForm.='<option value="'.$allgroup->id.'">'.$allgroup->title.'</option>';
		}
	$editForm.='</select>';
	$editForm.='</td><td>';
	$editForm.='<input class="u_form"  type="hidden" name="u_mdo" value="u_addGroupProfile">';
	$editForm.='<input class="u_form"  type="hidden" name="userid" value="'.$_GET["u_user"].'">';
	$editForm.='</td></tr>';
	$editForm.='<tr><td colspan="2" align="center"><input class="u_form" type="button" name="Add" value="Join group" onclick="uHttpRequest(\'divcontent\',\''.$u_url.'?&sid='.$sid.'&xuledit=1\',\'addusergroups\')"></td></tr>';
	$editForm.='</table></form>';
	}
	
	if(isset($_POST["u_cmyprofile"])) {
		$ok=true;
		$pass=0;
		if(!empty($_POST["u_passmd"])) {
			if(!field_validator($ling["mod_multiuser"]["users_password"],$_POST["u_passmd"],"string",$min_length="3")) { $u_c=$editForm; $ok=false; }
			else $pass=1;
		}	
		if(!field_validator($ling["users"]["email"],$_POST["u_email"],"email")) { $u_c=$editForm; $ok=false; }
		if($_POST["u_passmd"]!=$_POST["u_passmdr"]) {
			$u_messages=$ling["mod_multiuser"]["msg_passnotequal"];
			$u_c=$editForm;
			$ok=false;
		}
		if($ok) {
			if($pass) $db->query('update unak_users set password="'.$_POST["u_passmd"].'", realname="'.$_POST["u_realname_f"].','.$_POST["u_realname_l"].'", email="'.$_POST["u_email"].'", location="'.$_POST["u_location"].'", url="'.$_POST["u_url"].'", messanger="'.$_POST["u_messanger"].'", occupation="'.$_POST["u_occupation"].'" where id="'.$_POST["u_user"].'"');
			else $db->query('update unak_users set realname="'.$_POST["u_realname_f"].','.$_POST["u_realname_l"].'", email="'.$_POST["u_email"].'", location="'.$_POST["u_location"].'", url="'.$_POST["u_url"].'", messanger="'.$_POST["u_messanger"].'", occupation="'.$_POST["u_occupation"].'" where id="'.$_POST["u_user"].'"');
			
			// Upload User Picture
if($_FILES['pic']['name']) {
if(right($_FILES['pic']['name'],4)==".jpg" || right($_FILES['pic']['name'],4)==".JPG") {
		$uploaddir =  $cf["unak"]["root"]."/users/".$_POST["u_username"]."/";
		$uploadfile = $uploaddir."pic_". $_POST["u_username"].right($_FILES['pic']['name'],4);
		$uploadfilemin = $uploaddir."thumb_".$_POST["u_username"].right($_FILES['pic']['name'],4);
		if(!move_uploaded_file($_FILES['pic']['tmp_name'], $uploadfile)) {		$u_messages.=$uploadfile.$ling['msg']['failimageupload'];
		} else {
		chmod($uploadfile, 0644);
		$img = new img($uploadfile);
		$img->resize();
		$img->store($uploadfilemin);
		$u_messages.=$ling['msg']['imageuploaded'];
		}
	}
}
if($_POST["deletepic"]=="on") {	unlink($cf["unak"]["root"]."/users/".$_POST["u_username"]."/pic_".$_POST["u_username"].".jpg");
unlink($cf["unak"]["root"]."/users/".$_POST["u_username"]."/thumb_".$_POST["u_username"].".jpg");
}
			$u_messages=$ling["mod_multiuser"]["msg_userupdated"];
		} else $u_c=$editForm;
	} else $u_c=$editForm;
}


function _u_addGroupProfile(){
// ADD GROUP ROLE
}

if($u_mdo=="u_addGroupProfile") {
if($_POST["newgroup"])
$db->query('insert into unak_user_groups values('.maxRow("unak_user_groups").',"'.$_POST["userid"].'","'.$_POST["newgroup"].'","1")');
header("location:".$_SERVER['PHP_SELF']."?u_myprofile=1&u_user=".$_REQUEST["userid"]."&xuledit=1&sid=".$sid."");
}

function _u_delGroupProfile(){
// DELETE GROUP ROLE
}

if($u_mdo=="u_delGroupProfile"&&$_GET["rowid"]) {	
$db->query('delete from unak_user_groups where id="'.$_GET['rowid'].'"');
header("location:".$_SERVER['PHP_SELF']."?u_myprofile=1&u_user=".$_REQUEST["userid"]."&xuledit=1&sid=".$sid."");
}

} //end session restricted functions


//SESSION UNRESTRICTED FUNCTIONS

function __login_register__(){
//////////////////////////
// Profile management
//////////////////////////
}

function _u_register(){
///////////////////////////
//USER Register
///////////////////////////
}


if(isset($_GET["u_register"]) || isset($_POST["u_register"])) {
	$regForm='<form action="'.$_SERVER['PHP_SELF'].'?u_a='.$u_a.'&sid='.$sid.'" method="post">
		<table align="center" cellpadding="1" cellspacing="1" border="0" class="u_form">
		<tr><td align="center" colspan="2"><H3> '.$ling['login']['signup'].'</H3></td></tr>
		<tr><td align="right">'.$ling["mod_multiuser"]["users_username"].'&nbsp;*</td><td><input class="u_form"  class="u_form" type="text" name="u_user"></td></tr>
		<tr><td align="right">'.$ling["mod_multiuser"]["users_email"].'&nbsp;*</td><td><input class="u_form"   class="u_form" type="text" name="u_email"></td></tr>';
	if($cf["mod_multiuser"]["mailpass"]) $regForm.='<tr><td colspan="2">'.$ling["mod_multiuser"]["users_emailsend"].'</td></tr>';
	else $regForm.='<tr><td align="right">'.$ling["mod_multiuser"]["users_password"].'&nbsp;*</td><td><input class="u_form"  type="password" name="u_pass"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_passwordrepeat"].'&nbsp;*</td><td><input class="u_form"  type="password" name="u_rpass"></td></tr>';
	$regForm.='<tr><td align="right">First Name</td><td><input class="u_form"  type="text"  name="u_fname" value=""></td></tr>
	<tr><td align="right">Last Name</td><td><input class="u_form"  type="text"  name="u_lname" value=""></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_occupation"].'</td><td><input class="u_form"  type="text" name="u_occupation"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_website"].'</td><td><input class="u_form"  type="text" name="u_url"></td></tr>
	<tr><td align="right">'.$ling["mod_multiuser"]["users_messenger"].'</td><td><input class="u_form"  type="text" name="u_messanger"></td></tr>
	<tr valign="top"><td align="right">'.$ling['versions']['comments'].'</td><td><textarea class="u_form" name="u_location" cols="50" rows="15">'.$q->location.'</textarea></td></tr>';
	if ($cf["module"]["captcha"]&&$cf["mod_captcha"]["register"]) {
		$regForm.='<tr valign="top"><td align="right">'.$ling["mod_captcha"]["code"].':</td><td>__captcha__</td></tr>';
	}
	$regForm.='
	<tr><td align="left" colspan="2">* '.$ling["mod_multiuser"]["users_requiredfields"].'</td></tr>
	<tr><td colspan="2" align="center"><input class="u_form"  type="submit" class="u_form" name="u_register" value="'.$ling["button"]["save"].'">&nbsp;<input class="u_form"  class="u_form" type="reset" name="reset" value="'.$ling["button"]["reset"].'"></td></tr>
	</table>
	</form>';
	
	if(isset($_POST["u_user"])) {
		$ok=true;
		
		if ($cf["module"]["captcha"]&&$cf["mod_captcha"]["register"]&&!captcha_audit()) {
			$ok=false;
			header("location:?u_register=1&u_messages=".$ling["mod_captcha"]["failed"]."");
		}
		
		
		if(!field_validator($ling["mod_multiuser"]["users_username"],$_POST["u_user"],"alphanumeric_unders",$min_length="3")) { $u_c=$regForm; $ok=false; }
		if(!field_validator($ling["mod_multiuser"]["users_email"],$_POST["u_email"],"email")) { $u_c=$regForm; $ok=false; }
		
		if(!$cf["mod_multiuser"]["mailpass"]) {
			if(!field_validator("Password",$_POST["u_pass"],"alphanumeric_unders",$min_length="3")) { $u_c=$regForm; $ok=false; }
			if($_POST["u_pass"]!==$_POST["u_rpass"]) { 
				$u_messages=$ling["mod_multiuser"]["msg_passnotequal"];
				$u_c=$regForm;
				$ok=false; 
			}
		}
		
		if($ok) {
			$u=$db->get_var('select id from unak_users where username="'.$_POST["u_user"].'"');
			$m=$db->get_var('select id from unak_users where email="'.$_POST["u_email"].'"');
			if($u===NULL && $m===NULL) {
			$new_user_id=maxRow("unak_users");
			if($cf["mod_multiuser"]["mailpass"]) {
			$pass=substr(md5(rand(1000,10000)),0,8); 
			
			}
			else $pass=$_POST["u_pass"];
				$db->query('insert into unak_users values('.$new_user_id.',"'.$_POST["u_user"].'","'.md5($pass).'","'.$_POST["u_fname"].','.$_POST["u_lname"].'","'.$_POST["u_email"].'","'.$_POST["u_location"].'","'.$_POST["u_url"].'","'.$_POST["u_messanger"].'","'.$_POST["u_occupation"].'","0","'.time().'","'.time().'")');
				//insert into the group of registered users
				$db->query('insert into unak_user_groups values("'.maxRow("unak_user_groups").'","'.$new_user_id.'","1","")');
	
	//add user page and directory
	
	if($cf["mod_multiuser"]["personalpage"]!="") {			
	
	//add directories
	if(@is_dir($cf["unak"]["root"]."/users")){
	mkdir($cf["unak"]["root"]."/users/".$_POST["u_user"]);
	mkdir($cf["unak"]["root"]."/users/".$_POST["u_user"]."/images");
	}

	//add user pages
	allLang();
	if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
		for($i=0;$i<$c;$i++) {
			if($lang["sync"][$i]) {
			
			if($cf["mod_multiuser"]["membersec"]!="") $sec=$cf["mod_multiuser"]["membersec"];
			else {
			$sec1=maxRow("unak_sections_".$lang["name"][$i]);
			$sec=($sec1-1);
			}
				$max_art=maxRow("unak_articles_".$lang["name"][$i]);
				$ordr=$db->get_var('select max(ordr) from unak_articles_'.$lang["name"][$i].' where section='.($sec).' and parent="0"')+1;
				
				$db->query('insert into unak_articles_'.$lang["name"][$i].' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($_POST["u_fname"].' '.$_POST["u_lname"],ENT_QUOTES).'","'.htmlspecialchars($_POST["u_user"],ENT_QUOTES).'","'.($sec).'","0","'.$_POST["u_user"].'","'.time().'","1","0","'.$_POST["u_fname"].' '.$_POST["u_lname"].' personal page","","","","","","'.time().'")');
				$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$new_user_id.'","'.$max_art.'","'.$lang["name"][$i].'","5")');
			}
		}
	} else {
		
		if($cf["mod_multiuser"]["membersec"]!="") $sec=$cf["mod_multiuser"]["membersec"];
			else {
			$sec1=maxRow("unak_sections_".$sl);
			$sec=($sec1-1);
			}
		
		$max_art=maxRow("unak_articles_".$sl);
		
		$ordr=$db->get_var('select max(ordr) from unak_articles_'.$sl.' where section='.$sec.' and parent='.$parent.'')+1;
		
		$db->query('insert into unak_articles_'.sl.' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($_POST["u_fname"].' '.$_POST["u_lname"],ENT_QUOTES).'","'.htmlspecialchars($_POST["u_user"],ENT_QUOTES).'","'.($sec).'","0","'.$_POST["u_user"].'","'.time().'","1","0","'.$_POST["u_fname"].' '.$_POST["u_lname"].' personal page","","","","","","'.time().'")');
		$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$new_user_id.'","'.$max_art.'","'.$sl.'","5")');
		}

create_index($cf["unak"]["root"]."/users/".$_POST["u_user"]."/index.php",$max_art);
		
	}	//end add user pages		
		
				$u_messages=$ling["mod_multiuser"]["msg_userregistered"];
				
				if($cf["mod_multiuser"]["mailpass"]) {
					$to = $_POST["u_email"];
    				$from = $cf["admin"]["email"];
	    			$subject = $cf["site"]["title"].' registration details';
	    			$message = "Thanks for registering! Now you can connect on our website using \n username : ".$_POST["u_user"]."\n password: ".$pass."";
					unakmailer($from,$to,$subject,$message);
					$u_messages=$ling["mod_multiuser"]["msg_registermail"];
				}
			} else {
				$u_messages=$ling["mod_multiuser"]["msg_registerexist"];
				$u_c=$regForm;
			}
		}
		
} else {
		// Show form
		$u_c=$regForm;
	}
}


function _u_login(){
//////////////////////////
// LOGIN AND LOGOUT
//////////////////////////
}

if(isset($_POST["u_login"])||(isset($_GET["login_as"])&&$sid&&$turboadmin==5)) {

	// Check username and pass 
	
	$q=$db->get_row('select id,username,realname,email,permission,lastconnection,password from unak_users where username="'.$_REQUEST["u_user"].'"');
	
	if(isset($_GET["login_as"])&&$sid&&$turboadmin==5){
	$arr_sec_priv="";
	$arr_page_priv="";
	$loginok=1;
	} else {
if($cf["crypt"]["login"]&&$_POST["md5"]==hmac_md5(md5($kljuch.getenv('REMOTE_ADDR')),$q->password)) //crypted pass
	$loginok=1;
	elseif(md5($_POST["u_pass"])==$q->password) //not crypted pass
	$loginok=1;
	else $loginok=0;
	}	
	if($q->id!=NULL&&$loginok==1) {	
		$SID=session_newid();
		session_start_();
		$user_id=$q->id;
		$username=$q->username;
		$realname=$q->realname;
		$email=$q->email;
		$turboadmin=$q->permission;
		$lastconnection=$q->lastconnection;
		$userip=getenv('REMOTE_ADDR');
		$dte=date("Y-m-d");
		$tme=date("H:i:s");
		$editmode="preview";
		$timestamp=time();
		$sid=$SID;
		
		//check usergroups privileges
		$qry_user_groups=$db->get_results("SELECT unak_user_groups.group_id as group_id, unak_groups.title as title FROM unak_user_groups, unak_groups WHERE unak_user_groups.user_id='$user_id' AND unak_user_groups.group_id= unak_groups.id");
			//$db->debug();
			
		if(is_array($qry_user_groups))
		foreach($qry_user_groups as $rwg) {
			$tmp_user_gr=$tmp_user_gr.$rwg->group_id.",";
			$arr_user_gr[$rwg->group_id]=$rwg->title;
		}
		$tmp_user_gr=eregi_replace(",$","",$tmp_user_gr);
		//print $tmp_user_gr;
		if (strlen($tmp_user_gr)>=1)
			$sql_sel_gr="=".$tmp_user_gr;
		elseif(strstr($tmp_user_gr,","))
			$sql_sel_gr="in ($tmp_user_gr)";
		else
			$sql_sel_gr="=0";
		//	print "ss ".$sql_sel_gr;
		
		
		$qry=$db->get_results("SELECT DISTINCT unak_section_permissions.section_id as section_id, unak_section_permissions.permission as permission FROM unak_users, unak_groups, unak_user_groups, unak_section_permissions WHERE unak_section_permissions.user_id=$user_id OR (unak_user_groups.user_id=$user_id AND unak_users.id = unak_user_groups.user_id AND unak_section_permissions.group_id $sql_sel_gr AND unak_section_permissions.group_id=unak_user_groups.group_id) ORDER BY unak_section_permissions.section_id");
		//$db->debug();
		//print_r($qry);
		//exit;
		
		if (is_array($qry))	foreach($qry as $rw) if(!$arr_sec_priv[$rw->section_id]||$rw->permission>$arr_sec_priv[$rw->section_id]) $arr_sec_priv[$rw->section_id]=$rw->permission;

		$qryp=$db->get_results("SELECT DISTINCT unak_page_permissions.page_id as page_id, unak_page_permissions.permission as permission FROM unak_page_permissions WHERE unak_page_permissions.user_id=$user_id or unak_page_permissions.group_id $sql_sel_gr ORDER BY unak_page_permissions.page_id");
		//$db->debug();
		if (is_array($qryp)) foreach($qryp as $rwp) if(!$arr_page_priv[$rwp->page_id]||$rwp->permission>$arr_page_priv[$rwp->page_id]) $arr_page_priv[$rwp->page_id]=$rwp->permission;

		
session_register_(array('user_id','userip','username','email','turboadmin','arr_sec_priv','arr_page_priv','arr_user_gr','lastconnection','editmode','timestamp'));

		save_session_data();
		make_log("l","login");
		$db->query('update unak_users set lastconnection="'.time().'" where id="'.$q->id.'"');
		if($_SERVER['SERVER_PORT']=='443'&&!$cf["login"]["sslkeep"]){
			$u_urls=str_replace("https:","http:",$u_url);
			$u_urls=str_replace(":443/","/",$u_urls);
		}
		else $u_urls=$u_url;
		header("location:".$u_urls."?u_a=".$u_a."&sid=".$sid."");
	} else {
		header("location:".$u_urls."?login&u_a=".$u_a."&u_err=".urlencode($ling['users']['badlogin']));
	}
}

function _u_logout(){
//////////////////////////
// LOGIN AND LOGOUT
//////////////////////////
}
	
if(isset($_GET["u_logout"])) {
	session_destroy_($sid);
	$sid='';
	session_start();
	if (isset($_COOKIE[session_name()])) {
					  setcookie(session_name(), '', time()-42000, '/');
				}
	session_destroy();
	make_log("l","logout");
header("location:".$_SERVER['PHP_SELF']."?u_s=0&u_a=1&u_messages=".$ling["msg"]["logoutbye"]."");
}

//CREATE USER PAGES IF NOT AVAILABLE

if($u_do=="createUserPages"&&$cf["mod_multiuser"]["personalpage"]!=""){
//add user page and directory
		
	$q=$db->get_results('select id,username,realname,permission from unak_users');
	foreach($q as $row) {
	$u_name=split(",",$row->realname);
	$u_fname=$u_name[1];
	$u_lname=$u_name[0];	
	//add directories
	if(@is_dir($cf["unak"]["root"]."/users")&&!@is_dir($cf["unak"]["root"]."/users/".$row->username)){
	mkdir($cf["unak"]["root"]."/users/".$row->username);
	mkdir($cf["unak"]["root"]."/users/".$row->username."/images");
	
	//add user pages
	allLang();
	if($lang["sync"][array_search($sl,$lang["name"])]) {
		$c=count($lang["sync"]);
		for($i=0;$i<$c;$i++) {
			if($lang["sync"][$i]) {		
			if($cf["mod_multiuser"]["membersec"]!="") $sec=$cf["mod_multiuser"]["membersec"];
			else {
			$sec1=maxRow("unak_sections_".$lang["name"][$i]);
			$sec=($sec1-1);
			}
				$max_art=maxRow("unak_articles_".$lang["name"][$i]);
				$ordr=$db->get_var('select max(ordr) from unak_articles_'.$lang["name"][$i].' where section='.($sec).' and parent="0"')+1;
				
				$db->query('insert into unak_articles_'.$lang["name"][$i].' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($u_fname." ". $u_lname,ENT_QUOTES).'","'.htmlspecialchars($row->username,ENT_QUOTES).'","'.($sec).'","0","'.$row->username.'","'.time().'","1","0","'.$u_fname." ".$u_lname.' personal page","","","","","","'.time().'")');
				$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$row->id.'","'.$max_art.'","'.$lang["name"][$i].'","5")');
			}
		}
	} else {
		
		if($cf["mod_multiuser"]["membersec"]!="") $sec=$cf["mod_multiuser"]["membersec"];
			else {
			$sec1=maxRow("unak_sections_".$sl);
			$sec=($sec1-1);
			}
		
		$max_art=maxRow("unak_articles_".$sl);
		
		$ordr=$db->get_var('select max(ordr) from unak_articles_'.$sl.' where section='.$sec.' and parent='.$parent.'')+1;
		
		$db->query('insert into unak_articles_'.$sl.' values("'.$max_art.'","'.$ordr.'","'.htmlspecialchars($u_fname." ". $u_lname,ENT_QUOTES).'","'.htmlspecialchars($row->username,ENT_QUOTES).'","'.($sec).'","0","'.$row->username.'","'.time().'","1","0","'.$u_fname." ".$u_lname.' personal page","","","","","","'.time().'")');
		$db->query('insert into unak_page_permissions (id,user_id,page_id,lang,permission) values("'.maxRow("unak_page_permissions").'","'.$row->id.'","'.$max_art.'","'.$sl.'","5")');
		}

create_index($cf["unak"]["root"]."/users/".$row->username."/index.php",$max_art);
		
	}	//end add user pages	
	}
	header("location:".$_SERVER['PHP_SELF']."?u_s=0&u_a=1&sid=".$sid."&u_messages=User pages created");
}

?>