<?php
////////////////////////////////////////////////////////////////////////////
//This file is part of "Unak" CMS http://www.unak.net
//Author: Daniel Stoyanov daniel@unak.net, Atanas Tchobanov atanas@unak.net
//Contact: daniel@unak.net atanas@unak.net
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// UNAK-CMS is copyrighted by webdressy.com and distributed under the GPL license. Please read the LICENSE file.
////////////////////////////////////////////////////////////////////////////

///////////////////////////////////
//Install module
///////////////////////////////////
if($u_do=="modInstall" && $_POST["u_mod_install"]=="rss") {	
	$db->query('insert into unak_config values("module","rss","1")');
$db->query('insert into unak_config values("mod_rss","dir","modules/rss")');
$db->query('CREATE TABLE unak_rss (id INTEGER NOT NULL PRIMARY KEY, lang VARCHAR(3) NOT NULL, rss_id INTEGER NOT NULL, rss_url VARCHAR(255), rss_css VARCHAR(50) NOT NULL DEFAULT "rss")');
$db->query('insert into unak_config values("mod_rss","section","")');
$db->query('insert into unak_config values("mod_rss","numitems","10")');
header("location:".$_SERVER['PHP_SELF']."?sl=".$sl."&u_do=cMenuModules&u_messages=".$ling["module"]["installOk"]."&sid=".$sid."");
}
///////////////////////////////////
//Uninstall module
///////////////////////////////////
if($u_do=="modUninstall" && $_GET["u_mod_config"]=="rss") {
	
	// delete config vars
	$db->query('delete from unak_config where u_type="module" and u_var="rss"');
	$db->query('delete from unak_config where u_type="mod_rss"');
	$db->query('drop table unak_rss');
	// delete lang vars and update system lang files
	header("location:".$_SERVER['PHP_SELF']."?sl=".$sl."&u_do=cMenuModules&u_messages=".$ling["module"]["uninstallOk"]."&sid=".$sid."");
}

///////////////////////////////////
//Info module
///////////////////////////////////

if($u_do=="modInfo" && $_GET["u_mod_config"]=="rss") {
	$u_c="The rss module generates a rss feed named rss.xml in the cache directory.<BR> The module displays an rss feed with the function unak_rss. RSS system LastRSS by Vojtech Semecky";
	$u_c.="<a href=\"?u_do=cMenuModules&sid=".$sid."\"><< ".$ling['admin']['modules']."</a>";
}

////////////////////////////
/// MODULE CONFIG PARAMETERS
////////////////////////////
$module_name="rss";

///////////////////////////
/// MODULE GENERATION FUNCTION
///////////////////////////
getTree();
if($cf["mod_rss"]["numitems"]) $numitems=$cf["mod_rss"]["numitems"];
else $numitems=10;
if($u_do=="ceditA"||$u_do=="caddA") unak_rssgen($numitems);

function rssurl($sec,$art) {
	global $db,$sl,$u_a,$u_s,$u_ac,$u_sa,$u_do,$sid,$tree,$turboadmin;
		if($art) {
			$t=$tree[$art]["title"];
			$t=rss_tree($tree[$art]["parent_id"],$sec,$tmp).":".$t;
		} else {
			$t.=$u_sa["title"][$sec];
		}
return $t;
}

function rss_tree($id,$sec,$tmp="") {
	global $db,$sl,$u_sa,$u_s,$turboadmin,$tree;
		if(!$sec||$sec=="") $sec=$u_s;
		if($tree[$id]["parent_id"]==0) {
		if($id) $tmp=":".$tree[$id]["title"].$tmp;
		$tmp=$u_sa["title"][$sec].$tmp;
		} else {
		$tmp=":".$tree[$id]["title"].$tmp;
		$tmp=rss_tree($tree[$id]["parent_id"],$sec,$tmp);
	}
	return $tmp;
}

function htmlentities2unicodeentities ($input) {
  $htmlEntities = array_values (get_html_translation_table (HTML_ENTITIES, ENT_QUOTES));
  $entitiesDecoded = array_keys  (get_html_translation_table (HTML_ENTITIES, ENT_QUOTES));
  $num = count ($entitiesDecoded);
  for ($u = 0; $u < $num; $u++) {
   $utf8Entities[$u] = '&#'.ord($entitiesDecoded[$u]).';';
  }
  $input= str_replace("&rsquo;","'",$input);
  $input= str_replace("&ldquo;","\"",$input);
  $input= str_replace("&rdquo;","\"",$input);
  $input= str_replace("&ndash;","-",$input);

  return str_replace ($htmlEntities, $utf8Entities, $input);
}

function quotereplace($input) {
return str_replace("&rsquo;","'",$input);
}

function unak_rssgen($nlid) {
	global $sid, $u_s,$u_a,$u_ac,$db,$sl,$u_c,$u_url,$cf,$ling,$turboadmin,$editmode,$tree,$u_mod_rss;
	if($cf["mod_rss"]["section"])
	$rssq=$db->get_results('select * from unak_articles_'.$sl.' where permissions!=0 and (statut=1 or statut=2) and section="'.$cf["mod_rss"]["section"].'" order by id desc limit 0,'.$nlid.'');
	else
	$rssq=$db->get_results('select * from unak_articles_'.$sl.' where permissions!=0 and (statut=1 or statut=2) order by id desc limit 0,'.$nlid.'');
	
	foreach($rssq as $rssitem) { 
$rsslink=$u_url."?u_a=".$rssitem->id;
//print $rsslink;
$bodyitem .="
		<item>
			<title>".$rssitem->title."</title>
			<description><![CDATA[".$rssitem->abstract."]]></description>
			<link>".$rsslink."</link>
			<pubDate>".date("r",$rssitem->createdate)."</pubDate>
		</item>";
}
	//$db->debug();
	$body="<?xml version=\"1.0\" encoding=\"utf-8\"?> 
<rss version=\"2.0\"> 
<channel> 
	<title>".$u_url." RSS</title> 
	<link>".$u_url."</link> 
	<description>".$cf["meta"]["description"]."</description> 
	<copyright>(c) All rights reserved.</copyright>
	<generator>Unak-CMS</generator>
    <webMaster>".$cf["admin"]["email"]."</webMaster>
    <language>".$sl."</language>";
$body.=$bodyitem;

$body .="
</channel>
</rss>";
$path="cache/rss.xml";
$filenum=fopen($path,"w");
fwrite($filenum,$body);
fclose($filenum);
	
}

///////////////////////////
/// MODULE DISPLAY FUNCTION
///////////////////////////

getRss();

$function_public[]="unak_rss";
$function_public["unak_rss"][1]="Unique ID";
$function_public["unak_rss"]["help"]="The module displays an rss feed from external address. <BR>The module also generates a rss feed named rss.xml in the cache directory.<BR>RSS system LastRSS by Vojtech Semecky";
	
function unak_rsslink() {
	global $sl,$cf;
	if(is_file("./cache/rss-".$sl.".xml"))
	$link="<link href=\"cache/rss-".$sl.".xml\" rel=\"alternate\" type=\"application/rss+xml\" title=\"".$cf["site"]["title"]."\">";
	elseif(is_file("./cache/rss.xml"))
	$link="<link href=\"cache/rss.xml\" rel=\"alternate\" type=\"application/rss+xml\" title=\"".$cf["site"]["title"]."\">";
	return $link;
}
function unak_rss($nlid=0) {
	global $sid, $u_s,$u_a,$u_ablog,$u_ac,$db,$sl,$u_c,$u_url,$cf,$ling,$turboadmin,$editmode,$tree,$rss,$rsss;
	$rss = new lastRSS;
	$rss->cache_dir = './cache'; 
	$rss->cache_time = 1200; // one hour
	if($rsss[$nlid]["css"]=="")
	$rsss[$nlid]["css"]="rss";
	
	if (fopen($rsss[$nlid]["url"], 'r')) {
	if ($rs = $rss->get($rsss[$nlid]["url"])) {
        $mod_rss="<a class='".$rsss[$nlid]["css"]."_title' href=\"$rs[link]\">".$rs[title]."</a><br/>\n";
        $mod_rss.="<span class='".$rsss[$nlid]["css"]."_desc'>".$rs[description]."</span><br />\n";
            $mod_rss.="<ul class='".$rsss[$nlid]["css"]."_item'>\n";
            foreach ($rs['items'] as $item) {
                $mod_rss.="\t<li class='".$rsss[$nlid]["css"]."_item'><a class='".$rsss[$nlid]["css"]."_item' href=\"".$item[link]."\" title=\"".$item[description]."\">".$item[title]."</a></li>\n";
            }
            if ($rs['items_count'] <= 0) { 
           $mod_rss.="<li>Sorry, no items found in the RSS file :-(</li>"; 
            }
           $mod_rss.="</ul>\n";
    } else {
    	$mod_rss.="<P class=\"error\">Sorry, the provided url ".$rsss[$nlid]["url"]." is not a valid RSS feed.</P>"; 
    }
    } else {
    if($editmode!="edit") {
     $mod_rss.="<P class=\"error\">RSS failure: Sorry, the distant file opening is not allowed on this server.</P>"; 
     }
    }
	
	if($editmode=="edit") {	
	if (fopen($rsss[$nlid]["url"], 'r')) {
	$rssidcontent="rssidcontent".$nlid;
	$mod_rss.="<a  href=\"javascript://\" onclick=\"swapLayers('$rssidcontent'); return false;\"><img title=\"".$ling["mod_blog"]["editimage"]." ".$nlid."\" title=\"".$ling["mod_blog"]["editimage"]." ".$nlid."\" src=\"".$cf['dir']['templates']."/".$cf['current']['template']."/pics/edit.gif\" border=\"0\"></a>";
		if($_GET["visible"]==$rssidcontent) $visible="visible"; else $visible="hidden";
		$mod_rss.='<div id="'.$rssidcontent.'" align="left" style="Z-INDEX:'.$nlid.'; VISIBILITY: '.$visible.';  POSITION: absolute;">
		<table cellpadding="0" cellspacing="0"><tr><td class="blockedit_head"><img src="jscript/img/menu/drag.gif"></td></tr><tr><td><table cellpadding="3" cellspacing="0" width="100%"><tr><td class="blockedit">';
		$mod_rss.='<form name="rss" action="'.$u_url.'?sl='.$sl.'&sid='.$sid.'" method="POST"><input type="hidden" name="u_do" value="ceditrss"><input type="hidden" name="rss_id" value="'.$nlid.'"><input type="hidden" name="rss_rowid" value="'.$u_mod_rsss[$nlid]["rowid"].'"><input type="hidden" name="u_s" value="'.$u_s.'"><input type="hidden" name="u_a" value="'.$u_a.'">';
		$mod_rss.='External page address:';
		$mod_rss.='<BR>URL:';
		$mod_rss.='<textarea cols="20" rows="5" class="u_form" name="rss_url">'.$rsss[$nlid]["url"].'</textarea><BR>';
		$mod_rss.='<BR>CSS:';
		$mod_rss.='<textarea cols="20" rows="5" class="u_form" name="rss_css">'.$rsss[$nlid]["css"].'</textarea><BR>';
		$mod_rss.='<BR><input class="u_form" type="submit" name="Go" value="'.$ling['button']['save'].'">';
		$mod_rss.='</form>';
		
		$mod_rss.="<div align=\"right\"><a href=\"javascript://\" onclick=\"MM_showHideLayers('$rssidcontent','','hide');\"><img src=\"jscript/img/menu/close.gif\" border=0></a></div>";
		$mod_rss.='</td></tr></table></td></tr></table></div>';		
	}  else {
	 $mod_rss.="<P class=\"error\">RSS failure: Sorry, the distant file opening is not allowed on this server.</P>"; 
	}
	} //end admin section
	return $mod_rss;
}

function getRss() {
global $sid,$db,$sl,$cf,$u_a,$u_s,$turboadmin,$rsss;
	$rsss=array();
	//get defaults for all sections
	$q0=$db->get_results('select * from
	unak_rss where lang="'.$sl.'"');
		if(is_array($q0)){
			foreach($q0 as $node) {
				$id=$node->rss_id;
				$rsss[$id]["rss_id"]=$rss_id;
				$rsss[$id]["rowid"]=$node->rss_id;
				$rsss[$id]["url"]=$node->rss_url;
				$rsss[$id]["css"]=$node->rss_css;
			}
		}
	}



///////////////////////////////////
//MODULE CONTROLLERS
///////////////////////////////////

if($_POST["u_do"]=="ceditrss") {
if (maxRow("unak_rss")=="0") $maxRowId=1;
else $maxRowId=maxRow("unak_rss");
if(!$_POST["rss_rowid"]) {
//new rss
$db->query('insert into unak_rss values('.$maxRowId.',"'.$sl.'","'.$_POST["rss_id"].'","'.$_POST["rss_url"].'","'.$_POST["rss_css"].'")');
} elseif($_POST["rss_rowid"]) {
//update existing rss
$db->query('update unak_rss set rss_url="'.$_POST["rss_url"].'",rss_css="'.$_POST["rss_css"].'" where rss_id="'.$_POST["rss_rowid"].'"');
}
header('location:'.$u_url.'?sid='.$sid.'&u_s='.$_POST["u_s"].'&u_a='.$_POST["u_a"].'');
}


///////////////////////////////////
//LastRSS CODE
///////////////////////////////////

/*
 ======================================================================
 lastRSS 0.9.1
 
 Simple yet powerfull PHP class to parse RSS files.
 
 by Vojtech Semecky, webmaster @ webdot . cz
 
 Latest version, features, manual and examples:
 	http://lastrss.webdot.cz/

 ----------------------------------------------------------------------
 LICENSE

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License (GPL)
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 To read the license please visit http://www.gnu.org/copyleft/gpl.html
 ======================================================================
*/

/**
* lastRSS
* Simple yet powerfull PHP class to parse RSS files.
*/
class lastRSS {
	// -------------------------------------------------------------------
	// Public properties
	// -------------------------------------------------------------------
	var $default_cp = 'UTF-8';
	var $CDATA = 'nochange';
	var $cp = 'UTF-8';
	var $items_limit = 0;
	var $stripHTML = False;
	var $date_format = '';

	// -------------------------------------------------------------------
	// Private variables
	// -------------------------------------------------------------------
	var $channeltags = array ('title', 'link', 'description', 'language', 'copyright', 'managingEditor', 'webMaster', 'lastBuildDate', 'rating', 'docs');
	var $itemtags = array('title', 'link', 'description', 'author', 'category', 'comments', 'enclosure', 'guid', 'pubDate', 'source');
	var $imagetags = array('title', 'url', 'link', 'width', 'height');
	var $textinputtags = array('title', 'description', 'name', 'link');

	// -------------------------------------------------------------------
	// Parse RSS file and returns associative array.
	// -------------------------------------------------------------------
	function Get ($rss_url) {
		// If CACHE ENABLED
		if ($this->cache_dir != '') {
			$cache_file = $this->cache_dir . '/rsscache_' . md5($rss_url);
			$timedif = @(time() - filemtime($cache_file));
			if ($timedif < $this->cache_time) {
				// cached file is fresh enough, return cached array
				$result = unserialize(join('', file($cache_file)));
				// set 'cached' to 1 only if cached file is correct
				if ($result) $result['cached'] = 1;
			} else {
				// cached file is too old, create new
				$result = $this->Parse($rss_url);
				$serialized = serialize($result);
				if ($f = @fopen($cache_file, 'w')) {
					fwrite ($f, $serialized, strlen($serialized));
					fclose($f);
				}
				if ($result) $result['cached'] = 0;
			}
		}
		// If CACHE DISABLED >> load and parse the file directly
		else {
			$result = $this->Parse($rss_url);
			if ($result) $result['cached'] = 0;
		}
		// return result
		return $result;
	}
	
	// -------------------------------------------------------------------
	// Modification of preg_match(); return trimed field with index 1
	// from 'classic' preg_match() array output
	// -------------------------------------------------------------------
	function my_preg_match ($pattern, $subject) {
		// start regullar expression
		preg_match($pattern, $subject, $out);

		// if there is some result... process it and return it
		if(isset($out[1])) {
			// Process CDATA (if present)
			if ($this->CDATA == 'content') { // Get CDATA content (without CDATA tag)
				$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
			} elseif ($this->CDATA == 'strip') { // Strip CDATA
				$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
			}

			// If code page is set convert character encoding to required
			if ($this->cp != '')
				//$out[1] = $this->MyConvertEncoding($this->rsscp, $this->cp, $out[1]);
				$out[1] = iconv($this->rsscp, $this->cp.'//TRANSLIT', $out[1]);
			// Return result
			return trim($out[1]);
		} else {
		// if there is NO result, return empty string
			return '';
		}
	}

	// -------------------------------------------------------------------
	// Replace HTML entities &something; by real characters
	// -------------------------------------------------------------------
	function unhtmlentities ($string) {
		// Get HTML entities table
		$trans_tbl = get_html_translation_table (HTML_ENTITIES, ENT_QUOTES);
		// Flip keys<==>values
		$trans_tbl = array_flip ($trans_tbl);
		// Add support for &apos; entity (missing in HTML_ENTITIES)
		$trans_tbl += array('&apos;' => "'");
		// Replace entities by values
		return strtr ($string, $trans_tbl);
	}

	// -------------------------------------------------------------------
	// Parse() is private method used by Get() to load and parse RSS file.
	// Don't use Parse() in your scripts - use Get($rss_file) instead.
	// -------------------------------------------------------------------
	function Parse ($rss_url) {
		// Open and load RSS file
		if ($f = @fopen($rss_url, 'r')) {
			$rss_content = '';
			while (!feof($f)) {
				$rss_content .= fgets($f, 4096);
			}
			fclose($f);

			// Parse document encoding
			$result['encoding'] = $this->my_preg_match("'encoding=[\'\"](.*?)[\'\"]'si", $rss_content);
			// if document codepage is specified, use it
			if ($result['encoding'] != '')
				{ $this->rsscp = $result['encoding']; } // This is used in my_preg_match()
			// otherwise use the default codepage
			else
				{ $this->rsscp = $this->default_cp; } // This is used in my_preg_match()

			// Parse CHANNEL info
			preg_match("'<channel.*?>(.*?)</channel>'si", $rss_content, $out_channel);
			foreach($this->channeltags as $channeltag)
			{
				$temp = $this->my_preg_match("'<$channeltag.*?>(.*?)</$channeltag>'si", $out_channel[1]);
				if ($temp != '') $result[$channeltag] = $temp; // Set only if not empty
			}
			// If date_format is specified and lastBuildDate is valid
			if ($this->date_format != '' && ($timestamp = strtotime($result['lastBuildDate'])) !==-1) {
						// convert lastBuildDate to specified date format
						$result['lastBuildDate'] = date($this->date_format, $timestamp);
			}

			// Parse TEXTINPUT info
			preg_match("'<textinput(|[^>]*[^/])>(.*?)</textinput>'si", $rss_content, $out_textinfo);
				// This a little strange regexp means:
				// Look for tag <textinput> with or without any attributes, but skip truncated version <textinput /> (it's not beggining tag)
			if (isset($out_textinfo[2])) {
				foreach($this->textinputtags as $textinputtag) {
					$temp = $this->my_preg_match("'<$textinputtag.*?>(.*?)</$textinputtag>'si", $out_textinfo[2]);
					if ($temp != '') $result['textinput_'.$textinputtag] = $temp; // Set only if not empty
				}
			}
			// Parse IMAGE info
			preg_match("'<image.*?>(.*?)</image>'si", $rss_content, $out_imageinfo);
			if (isset($out_imageinfo[1])) {
				foreach($this->imagetags as $imagetag) {
					$temp = $this->my_preg_match("'<$imagetag.*?>(.*?)</$imagetag>'si", $out_imageinfo[1]);
					if ($temp != '') $result['image_'.$imagetag] = $temp; // Set only if not empty
				}
			}
			// Parse ITEMS
			preg_match_all("'<item(| .*?)>(.*?)</item>'si", $rss_content, $items);
			$rss_items = $items[2];
			$i = 0;
			$result['items'] = array(); // create array even if there are no items
			foreach($rss_items as $rss_item) {
				// If number of items is lower then limit: Parse one item
				if ($i < $this->items_limit || $this->items_limit == 0) {
					foreach($this->itemtags as $itemtag) {
						$temp = $this->my_preg_match("'<$itemtag.*?>(.*?)</$itemtag>'si", $rss_item);
						if ($temp != '') $result['items'][$i][$itemtag] = $temp; // Set only if not empty
					}
					// Strip HTML tags and other bullshit from DESCRIPTION
					if ($this->stripHTML && $result['items'][$i]['description'])
						$result['items'][$i]['description'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['description'])));
					// Strip HTML tags and other bullshit from TITLE
					if ($this->stripHTML && $result['items'][$i]['title'])
						$result['items'][$i]['title'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['title'])));
					// If date_format is specified and pubDate is valid
					if ($this->date_format != '' && ($timestamp = strtotime($result['items'][$i]['pubDate'])) !==-1) {
						// convert pubDate to specified date format
						$result['items'][$i]['pubDate'] = date($this->date_format, $timestamp);
					}
					// Item counter
					$i++;
				}
			}

			$result['items_count'] = $i;
			return $result;
		}
		else // Error in opening return False
		{
			return False;
		}
	}
}
 
?>